	PAGE
;Initialization routine for FastPlus
;Copyright 1988 by Mel Patrick
;FileName - FPINIT/ASM
;
initst	LD	HL,buffer	;point to buffer
	LD	A,@date		;get date from system
	RST	svc
	LD	HL,buffer+6	;move the date to the LOG file
	LD	DE,usrec+6	;when to move it to
	LD	BC,2
	LDIR			;and move over the YY to the filename
	LD	A,(buffer)	;check in case of OCT (10)
	CP	'1'		;check if oct to Dec
	JP	Z,dok		;go if ok to use
	LD	A,(buffer+1)	;look for month of x0, which is not valid
	CP	'0'		;if zero abort program start
	JP	NZ,dok		;else its ok to use
	LD	HL,bdate	;else point to bad date
	LD	A,@dsply	;show it
	RST	svc
todos	LD	HL,0
	LD	A,@exit
	RST	svc
dok	LD	HL,ctrl		;point to control word
	RES	0,(HL)		;set flag in bit for load all banks
	CALL	cls		;clear the video display
	IF	owner		;else check for registered owner
	CALL	freg		;display normal screen
	CALL	delay2		;wait for 2 seconds
	ENIF			;end of conditional
	IF	NOT,owner	;see if OWNER=1 (shareware)
	CALL	fpsw		;display screen for shareware version
	ENIF			;end of conditional
	LD	HL,vernum	;where version number is
	LD	DE,title+33	;where to shuffle it too
	LD	BC,4		;bytes to move
	LDIR			;and do it
	LD	A,1		;set for start at public board
	LD	(board),A	;save it
	CALL	ldcfg		;load the configuration module
	CALL	ramtst		;we have about 250 bytes for a ram test
	CALL	cls		;then clear the video/protect lines
	LD	A,@vdctl	;now protect 3 lines on video
	LD	B,7
	LD	C,4
	RST	svc
reprt	LD	HL,prtest	;initializing message
	LD	A,@print	;send to printer
	RST	svc		;Z=ok, NZ=error
	JR	NZ,init3	;skip if printer off line
	LD	HL,ctrl		;point to control byte
	SET	1,(HL)		;else set bit to tell its on
	JR	init4		;and continue
init3	LD	HL,prtm		;show printer message
	LD	A,@dsply	;on the video
	RST	svc
	LD	B,3		;then beep 3 times to get attention
blp	PUSH	BC		;save counter
	LD	B,3		;sound to make
	LD	A,@sound
	RST	svc
	LD	BC,(bdelay)	;get delay
	LD	A,@pause
	RST	svc		;and wait
	POP	BC		;get back counter
	DJNZ	blp		;wait
	LD	H,10		;delay of 60 seconds
pwaitt	LD	C,150		;LSB delay
pwait	LD	B,200		;MSB delay
pwait0	PUSH	BC		;save these regs
	LD	A,@kbd		;then wait for a key
	RST	svc
	POP	BC		;get back regs
	JR	NZ,pwait1	;continue if nothing was pressed
	AND	5fH		;convert to upper case
	CP	'R'		;R= to Re-try?
	JR	Z,reprt		;go if yes
	CP	'C'		;else want to continue?
	JR	Z,pwait2	;continue if C
	JR	init3		;wait til right answer
pwait1	DJNZ	pwait0		;loop for outside count
	DEC	C		;else minus from outside counter
	JR	NZ,pwait	;if not done, load B with another 200
	DEC	H		;else minus 1 from H
	JR	NZ,pwaitt	;and wait for H loops
pwait2	LD	HL,ctrl		;point to control byte
	RES	1,(HL)		;else printer is off
init4	RES	2,(HL)	 	;set for NO CARRIER DETECTED
	LD	DE,'OD'		;find display DCB
	LD	A,@gtdcb
	RST	svc
	LD	(vdcb),HL	;save the vector address
	LD	DE,'RP'		;find printer address
	LD	A,@gtdcb
	RST	svc
	LD	(pdcb),HL	;save address
	DI			;turn off for code insertion
	LD	HL,(48h)	;get address of usual routine
	LD	(rsvect),HL	;save it for exiting
	LD	HL,rechr	;get my routine for getting chars
	LD	(48h),HL	;insert in location
	LD	HL,80H		;TRSDOS location for interupts
	LD	A,(HL)		;get byte normally used
	LD	(intbit),A	;save it for exit
	SET	5,(HL)		;turn on inteupts from RS232
	LD	A,(HL)		;get the new bit
	OUT	(0e0h),A	;turn on port value
	EI			;turn on the interupts
	LD	HL,ctrl		;check for 1200 baud operation
	BIT	3,(HL)		;Z=300 baud only NZ=1200 avail
	JR	Z,no1200	;go if 300 baud modem only
	SET	6,(HL)		;else enable 1200 baud to start with
no1200	CALL	stbaud		;go set the baud to use
	CALL	mdinit		;and initialize modem for use
	CALL	clrtyp		;clear type ahead incoming
	IN	A,(0E8H)	;read normal value from modem first
	AND	20H		;mask out all the bits
	LD	(cdval),A	;save the value used for all checking
	LD	C,8		;now use a slot for timer
	LD	A,@adtsk	;add task to chain
	LD	DE,timer	;point to timer subroutine
	RST	svc		;install it
	LD	C,1		;setup carrier detect subroutine
	LD	A,@adtsk
	LD	DE,detect
	RST	svc
	LD	A,@flags	;find the flags pointer
	RST	svc
	LD	(flags),IY	;save it for later case switching
	CALL	rtime		;reset keyboard input timer
	CALL	reupdt		;reset update rate on entry
	LD	HL,drv1		;start of default drive list
	LD	A,(HL)		;get a byte
	LD	(sf+8),A	;SYSINFO drive
	INC	HL
	LD	A,(HL)		;get next
	LD	(df+3),A	;DL/FPF file
	INC	HL
	LD	A,(HL)		;get next
	LD	(uf+6),A	;USERS/FPF file
	INC	HL
	LD	A,(HL)		;get next
	LD	(mailf+5),A	;MAIL FILE
	INC	HL
	LD	A,(HL)		;get USERS/LOG (was chat)
	LD	(usrec+13),A	;user record uses same drive
	LD	A,(buldrv)	;get drive to use for BULLS
	LD	(bulrec+10),A	;used for where to store BULLS
	LD	B,0		;look for HIGH$
	LD	HL,0		;find memsize
	LD	A,@high		;find HIGH mem pointer
	RST	svc
	PUSH	HL		;save it
	INC	HL		;add 1 to it
	LD	A,H		;test for full memory
	OR	L		;Z=we have it all
	POP	HL		;restore it first
	JR	Z,fulmem	;go if full memory
	DEC	H		;back up 256 now
	LD	L,0FFH		;set L to end of block
	LD	A,H		;HL=TOP of MEMORY to use
	SUB	7FH		;calc blocks to load MAX
	LD	(bankld),A	;save for users bank
	LD	H,A		;move for saving memory size
	DEC	H		;make it HEX from 1 - 7F
	LD	(maxram),HL	;save length of ram continuous
;have to allow for L=FF....
	LD	C,78		;each user uses 78 bytes
	LD	A,@div16	;so divide total by 78
	RST	svc
	LD	(maxusr),HL	;save quotient
	JR	fulm		;and skip next part
fulmem	LD	A,128		;blocks to save or load
	LD	(bankld),A	;save it for loading
	LD	HL,(maxusr)	;get maximum users
fulm	CALL	donum		;DE to NUMBUF for conversion
	LD	DE,bstat	;where to move it to
	CALL	copy3		;and shift out 3 digits
	LD	HL,track1	;second option address
	BIT	6,(HL)		;see if SOUND board or CASSETTE
	JR	Z,sndbrd	;go if sound board
	LD	A,0FFH		;else set for cassette port
	LD	(3BDH),A	;insert in DOS routine
	LD	(3C3H),A	;now its for the cassette
sndbrd	BIT	7,(HL)		;see if SPEED up board installed
	JR	Z,nospeed	;go if not
	LD	A,0CDH		;set up a call to my routine
	LD	(3BEH),A	;to use my routine
	LD	DE,mybeep	;point to new sound routine
	LD	(3BFH),DE	;insert in @SOUND routine
	LD	DE,3080H	;shows up as 8030 in memory
	LD	(3D7H),DE	;insert new sound value
nospeed	BIT	3,(HL)		;see if allowed to remove your uploads
	JR	Z,cryu		;Z=can not remove your uploads
	PUSH	HL		;else save pointer
	LD	A,5		;set it up so we can
	LD	(menu4a),A	;insert a 5 (call)
	LD	HL,rmvwrd	;point to address of command
	LD	(menu4b),HL	;insert in message menu
	POP	HL		;restore pointer
cryu	BIT	0,(HL)		;Z=use TERMINATE, NZ=USE GOODBYE
	JR	Z,cryz		;continue if TERMINATE
	LD	HL,gmsg		;GOODBYE
	LD	DE,tmsg		;TERMINATE
	LD	BC,11		;bytes to shift
	LDIR			;we now have a new command
cryz	LD	A,(track2)	;see if HELP enabled
	BIT	0,A		;Z=no, NZ=yes
	JR	Z,nh
	LD	DE,hlpwrd	;point to word in menu
	LD	HL,menu0h	;first one
	CALL	hinsert
	LD	HL,menu3h
	CALL	hinsert
	LD	HL,menu4h
	CALL	hinsert
	LD	HL,menu5h
	CALL	hinsert
	LD	HL,menu6h
	CALL	hinsert
	XOR	A
	LD	(gthelp),A	;change RET to NOP
nh	JP	bbs		;and start the BBS program itself
;
hinsert	LD	(HL),5		;for a branch
	INC	HL
	LD	(HL),E		;insert LSB
	INC	HL
	LD	(HL),D		;then MSB
	RET			;and then back
;
prtm	DM	10,'Printer not READY!',10
	DM	10,'<R>etry or <C>ontinue : ',3
;
prtest	DM	'-Initialized-',13,3
;
ramtst	LD	HL,ramsg	;show message
	LD	A,@dsply
	RST	svc
	LD	A,1		;start with bit 1
	LD	(val1),A	;insert in variable
	LD	HL,1		;start with bank 1
	LD	(val2),HL	;save for toggling banks
	PUSH	HL
	POP	BC
	LD	A,@bank
	RST	svc		;switch to bank 1 to start
	LD	B,2		;total switches with bit tests
memlp	PUSH	BC		;save it
memlp0	LD	HL,tstmsg	;point to test message
	LD	A,@dsply
	RST	svc		;show events
	LD	HL,8000H	;start here
	PUSH	HL
	PUSH	HL		;make all the same
	POP	DE		;de=destination
	POP	BC		;bc=size
	DEC	BC		;minus 1
	INC	DE		;point to HL+1
	LD	A,(val1)	;get value
	LD	(HL),A		;insert in memory
	LDIR			;and block move the whole lot
	LD	HL,8000H	;where to start check
	PUSH	HL
	POP	BC		;get size to check
	LD	A,(val1)	;get value stuffed into memory
	CPL			;turn on all other bits
	CPIR			;and do a block compare
	JP	Z,memerr	;go if memory error
	LD	A,(tbit)	;get test bit
	INC	A		;add 1 to it
	LD	(tbit),A	;insert back in
	LD	A,(val1)	;get last bit used
	RLCA			;shift left with carry set
	LD	(val1),A	;insert back in
	JR	NC,memlp0	;continue to test all 8 bits in memory
	LD	A,'0'		;reset bit to 0
	LD	(tbit),A	;for next test
	LD	BC,(val2)	;get last bank selected
	INC	BC		;add 1 to get next
goon	LD	(val2),BC	;save it
	LD	A,C		;get bank testing now
	ADD	A,30H		;make it ascii
	LD	(tbank),A	;insert for message
	CP	'3'		;see if testing non-existant bank
	JR	Z,skptst	;skip if testing wrong bank
	LD	A,@bank		;select this bank
	RST	svc		;do it
skptst	POP	BC		;get back outside loop counter
	JR	NZ,no128	;skip if not 128K RAM installed
	DJNZ	memlp		;loop til all three banks tested
	LD	HL,memok	;memory ok
	LD	A,@dsply
	RST	svc
	CALL	delay2		;wait before return
	RET			;and go back
;
memerr	LD	HL,rer		;point to error message
	LD	A,@dsply
	RST	svc
	POP	AF		;fix the stack
memer0	POP	AF		;remove RET address
	JP	todos		;and back to TRSDOS
;
no128	LD	HL,ber		;point to error message
	LD	A,@dsply
	RST	svc
	JR	memer0		;and just back to TRSDOS
;
ramsg	DM	10,10,'Testing RAM',10,13
tstmsg	DM	1DH,1EH,'Bank <'
tbank	DM	'1>....Bit <'
tbit	DM	'0>',3
rer	DM	10,10,'Memory Error!',13
memok	DM	10,10,'Memory OK!',13
ber	DM	10,10,'128K Memory not Available',13
bdate	DM	10,10,'Date Not Set.',13
;
ABS	DB	0		;absolute end of program
;
ldcfg	LD	HL,ldcmsg	;show we are trying to LOAD
	LD	A,@dsply
	RST	svc		;show it on video
	LD	HL,cfgname	;point to configuration name
	CALL	crfcb		;create a file control block
	CALL	flopen		;open the file ONLY
	JR	NZ,svcfg	;if we can't find it, save it
	LD	HL,welcome	;where it has to overlay
	LD	BC,3F2H		;size of module
ldclp	CALL	fget		;read in configuration
	JR	NZ,svcfg	;go if load error
	LD	(HL),A		;insert in memory
	INC	HL		;point to next
	DEC	BC		;minus 1 from counter
	LD	A,B
	OR	C
	JR	NZ,ldclp	;loop til loaded
	RET			;go back now, all loaded
;
svcfg	LD	HL,svcmsg	;point to saving msg
	LD	A,@dsply
	RST	svc
	LD	HL,cfgname	;point to configuration name
	CALL	crfcb		;create a fcb
	CALL	flinit		;and CREATE the file on first drive
	JR	NZ,serr		;go if error
	LD	HL,welcome	;point to start of module
	LD	BC,3F2H		;size to write out
svclp	PUSH	BC		;save counter
	CALL	fcput		;ld C,(hl), write to disk
	POP	BC		;get back counter
	INC	HL		;point to next
	JR	NZ,serr		;go if saving error
	DEC	BC
	LD	A,B
	OR	C		;test for done
	JR	NZ,svclp	;loop til done
	CALL	closef		;and close the file now
	RET			;and go back now
;
serr	OR	0C0H		;mask error code
	LD	C,A		;move it
	LD	A,@error	;and display it
	RST	svc
	POP	HL		;remove RET address
	JP	todos		;and back to DOS ready
;
cfgname	DM	'FASTPLUS/CFG',13
;
ldcmsg	DM	'Loading FastPlus II Configuration File',13
svcmsg	DM	10,'Creating FastPlus II Configuration File',10,13
;
