	PAGE
;Main input routine for FastPlus.
;Exit on CR
;Copyright 1988 by Mel Patrick
;Filename - INPUT/ASM
;
uinput	CALL	upper		;switch to upper case
	JR	input		;and do the input routine
linput	CALL	lower		;switch to lower or upper
input	LD	(data),HL	;save pointer in case of search
	LD	(len2),A	;save maximum length of input
	XOR	A		;remove count so far
	LD	(len1),A	;insert for checking
	LD	(inexit),A	;set abort off
	LD	(lpoint),HL	;save pointer to line
	LD	A,(vflag)	;test for visible/inv
	OR	A		;0=normal 1=invisble
	CALL	NZ,curoff	;turn off cursor if inv
inlp	PUSH	HL		;check for carrier first
	CALL	cd		;check for carrier
	JR	Z,inlp0		;continue if still there
	POP	HL		;else get back pointer
	RET			;and go back
inlp0	POP	HL		;get back pointer
	CALL	gtwrap		;check for wrapped lines
	CALL	scan		;quick keyscan
	JR	NZ,inlp		;loop and check if no input
	CP	8		;backspace?
	JP	Z,back1		;go if yes
	CP	9		;else tab
	JP	Z,tab		;go if yes
	CP	13		;else enter key?
	JP	Z,enter		;go if yes
	CP	24		;else start line over
	JP	Z,backlp	;go if yes
	CP	82H		;exit used sometimes F2
	JR	NZ,chk4		;go if not
	LD	(inexit),A	;else make flag NZ
	RET			;and go back
chk4	LD	C,A		;move for storing
	LD	A,(len1)	;get input length
	LD	B,A		;move to loop
	LD	A,(len2)	;get max
	CP	B		;if same then line is full
	JP	Z,dowrap	;if yes, see if wrap wanted
	INC	B		;else add 1 to length
	LD	A,B		;get it
	LD	(len1),A	;insert new length
	LD	A,C		;get character back
	LD	(HL),A		;save character
	INC	HL		;point to next
	LD	A,(vflag)	;test for mask on
	OR	A		;0=vis 1=inv
	JR	Z,itsvis	;go if visible
	LD	A,'#'		;else replace with a # sign
	JR	itsv0		;and continue
itsvis	LD	A,C		;get back original character
itsv0	CALL	output		;send for display
	JP	inlp		;and continue processing
enter	LD	(HL),A		;insert c/r in line
	CALL	output		;send ENTER back to remote
	LD	A,(vflag)	;test for vis/inv flag
	OR	A		;0=vis 1=inv
	CALL	NZ,curon	;turn the cursor on
	LD	A,(len1)	;get input length
	LD	B,A		;move
	LD	A,(len2)	;get max allowed
	CP	B		;check for same
	RET	Z		;back if line full
	PUSH	HL		;else save pointer
	SUB	B		;length of remainder A-B
	LD	B,A		;insert in loop
enclr	LD	(HL),' '	;space out to end of line
	INC	HL		;do it
	DJNZ	enclr
	POP	HL		;point back to original position
	LD	(HL),13		;and put a c/r back in
entext	RET			;and back now
tab	LD	B,6		;allow 6 spaces max per tab
tabchr	LD	A,(len1)	;get current length
	LD	C,A		;move for checking
	LD	A,(len2)	;get max allow
	CP	C		;if full, no more
	JR	Z,tabfl		;go if no more tabs allowed
	INC	C		;else add 1
	LD	A,C		;get it
	LD	(len1),A	;insert back in routine
	LD	A,' '		;and do a space now
	LD	(HL),' '	;insert in line
	INC	HL		;point to next
	CALL	output		;send character out
	DJNZ	tabchr		;and loop for 6 max
tabfl	JP	inlp		;and then back
back1	LD	A,(len1)	;get input length
	OR	A		;0=nothing entered
	JR	Z,tabfl		;back if you can't backspace
	DEC	A		;else minus 1 from count
	LD	(len1),A	;insert in var
	LD	(HL),' '	;insert a space char
	DEC	HL		;backup pointer
	LD	A,8		;do a backspace
	CALL	output
	JR	tabfl		;and then continue
backlp	LD	A,(len1)	;get length we are at now
	OR	A		;0=no input
	JR	Z,tabfl		;no restart line if full
	LD	B,A		;else move length
bkspc	LD	A,' '		;insert a space
	LD	(HL),A		;in buffer
	LD	A,8		;ld a backspace char
	CALL	output		;send to screen/rs232
	DEC	HL		;back up 1
	DJNZ	bkspc		;loop til line empty
	XOR	A		;remove length
	LD	(len1),A	;insert
	JR	tabfl		;and all done
dowrap	LD	A,(wflag)	;see if wrap allowed
	OR	A		;0=no 1=yes
	JR	Z,tabfl		;just continue if not on
	LD	A,C		;get character
	CP	' '		;if space on end of line, forget it
	JR	NZ,nosp		;continue if not
gexit	LD	A,13		;insert a c/r
	LD	(HL),A		;in line
	CALL	output		;then print one on the screen
	JP	entext		;insert c/r and check printer/disk
nosp	LD	DE,buff2
	LD	A,C
	LD	(DE),A		;save 1 char in wrap buffer
	LD	(HL),A		;if on, then save character
	INC	HL		;point to next
	INC	DE
	LD	A,13
	LD	(DE),A
	LD	(HL),A		;else stuff in an end marker
	LD	(wrlen),A	;insert a wrap length NZ
	LD	A,(len2)	;get maximum length
	LD	B,A		;move into loop for search
wsrch	LD	A,(HL)		;and look for a space
	CP	' '		;you can end at a space
	JR	Z,wact		;go if found
	DEC	HL		;else back up 1
	DJNZ	wsrch		;and search for a space
	CALL	cret		;c/r
	RET			;else just ret
wact	LD	(HL),13		;else stuff in carriage return
	LD	B,0		;then zero counter
	LD	DE,buff2	;point to wrap buffer
wmore	INC	HL		;point to start of text
	LD	A,(HL)		;read byte from string
	LD	(DE),A		;insert in new buffer
	INC	B		;add 1 to length
	INC	DE
	CP	13		;end of line reached?
	JR	NZ,wmore	;continue til cr found
	DEC	B		;minus for extra character
	LD	A,B		;get wrap length
	LD	(wrlen),A	;save in wrap length
wera	LD	A,8		;then do a few backspaces
	CALL	output		;hl not important
	DJNZ	wera		;step back to space
	JP	gexit		;check for disk/printer before exit
gtwrap	LD	A,(wrlen)	;check for anything in wrap buffer
	OR	A		;0=nothing
	RET	Z		;back if no one home
	XOR	A		;remove data for wrap buffer
	LD	(wrlen),A	;so we don't use it again
	LD	DE,buff2	;point to wrap buffer
mvwrp	LD	A,(DE)		;get a byte
	CP	13		;check for end of string
	RET	Z		;back if end found
	LD	(HL),A		;else move to buffer
	PUSH	DE		;save pointer
	CALL	output		;send back to system
	POP	DE		;point back to buffer
	LD	A,(len1)	;get input length
	INC	A		;add 1 to it
	LD	(len1),A	;save it again
	INC	DE		;point to next
	INC	HL
	JR	mvwrp		;and move the wrap buffer out
;
type1	CALL	out		;send out a msg first
type2	LD	A,16		;length to get for input
type3	LD	HL,buffer	;point to a buffer
	PUSH	HL		;save pointer
	CALL	uinput		;get upper case input
	POP	HL		;get back pointer
	RET			;and back to callers
;
