	PAGE
;Module for signing onto the new FastPlus
;Copyright 1988 by Mel Patrick
;Filename : LOGON/ASM
;
	CALL	rtime		;reset input timer (totally)
	CALL	bank1		;select users bank
	CALL	wrpoff		;turn off word wrap
	LD	HL,welcome	;point to welcome msg
	CALL	out		;send
	LD	A,(maxtry)	;get tries allowed for signon
	INC	A		;add one for tries
	LD	(try),A		;move it
signon	CALL	cv5		;send out name prompt
	CALL	ckola		;check A for online
	JR	Z,sign0		;continue if off
	LD	HL,8000H	;start of search
	CALL	cv6		;get total users and offset
mlp	PUSH	HL		;move to IX
	POP	IX		;=user data
	CALL	b7ix75		;check for master sysop
	JR	NZ,gmast	;go if found
	CALL	addsub		;ADD HL,DE, DEC BC
	JR	NZ,mlp		;scan for master
	JR	sign0		;continue if not found
gmast	LD	(usradd),HL	;save the address of user
	CALL	dspnam		;and show users name
	LD	HL,online
	SET	6,(HL)		;signal we know user
	LD	A,(maxtry)	;reset error tries
	LD	(try),A		;save it
	JP	repas		;and continue with password
sign0	CALL	clrtyp		;empty type ahead buffer
	CALL	cd		;check for carrier
	JP	NZ,lostcd	;go if cd was lost at this point
	CALL	type2		;INPUT/ASM A=16, HL=BUFFER
	CALL	cv17		;check for boot, and cd
alogg	CALL	adderr		;and decrement the trys
	OR	A		;if 0, then abort
	JP	Z,badlog	;go if he can't do it right
	LD	A,(len1)	;get length entered
	CP	5		;must be >5
	JR	NC,alogg0	;continue if enough entered
	JR	signon		;else try again
;
alogg0	LD	HL,buffer	;else we better count spaces
	LD	B,16		;bytes to check through
	LD	C,0		;use as a counter
	LD	A,(HL)		;look for leading space
	CP	' '		;if name entry starts with space
	JP	Z,signon	;redo it
chkspc	LD	A,(HL)		;get a byte
	CP	13		;look for c/r
	JR	Z,eol		;go if end of line
	CP	' '		;count spaces
	JR	NZ,notspc	;go if not a space
	INC	C		;else we have a space
notspc	INC	HL		;point to next
	DJNZ	chkspc		;and check for length
eol	LD	A,C		;get spaces entered
	CP	2		;allowed max of 1
	JP	NC,signon	;redo if too many
	LD	HL,ctrl		;check to see name format allowed
	BIT	4,(HL)		;0=need 2 names, 1=1 name allowed
	JR	NZ,ok2use1	;go if ok to use 1 name or two
	LD	A,C		;else must be 2 names
	CP	1		;must be 1 space
	JR	Z,ok2use1	;continue if alrigth to use
	LD	HL,err1		;else please use your first and last
	CALL	out		;send
	JP	signon		;and repeat
ok2use1	CALL	cv5		;Name :
	LD	HL,buffer	;point to name entered
	LD	B,16		;bytes to show
	CALL	fmtnam		;show name
	LD	HL,msg88	;CORRECT Y/N
	CALL	cv12		;check for a Y response
	JP	NZ,signon	;repeat if not correct
	CALL	cd		;check for a carrier
	JP	NZ,lostcd	;restart if lost
	CALL	cret		;c/r
	CALL	usrch		;search for this user
	JP	NZ,newusr	;go if new user on system
	LD	(usradd),HL	;save it
	PUSH	HL
	POP	IX		;move user address in index
repas	LD	A,(IX+75)	;check for VIS/inv pdw
	AND	8
	LD	(vflag),A	;either a 0/NZ
	LD	HL,q2		;Password?
	CALL	out
	LD	A,(online)	;check for master
	BIT	6,A		;Z=not known
	JR	Z,rp0		;continue if no master
	CALL	p2pw		;point to password
	LD	A,(vflag)	;if inv, then don't show us
	OR	A		;NZ=inv Z=vis
	JR	Z,ok2s		;go if ok to show
dns	LD	A,'#'		;else don't show it
	CALL	output		;send it out
	DJNZ	dns		;loop til done
	JR	ok2c		;and continue
ok2s	CALL	fmtnam		;and display to screen
ok2c	XOR	A		;remove inv flag
	LD	(vflag),A	;save it
	JR	notres		;and continue now
rp0	LD	A,7		;bytes to use for input
	CALL	type3		;INPUT/ASM A=length, HL=BUFFER
	XOR	A		;then remove vis/inv flag
	LD	(vflag),A
	CALL	cv17		;check for BOOT and CD
	CALL	cv18		;check length input
	JR	Z,repas		;redo password if nothing
	CALL	p2pw		;point to password
	LD	DE,buffer	;point to password he entered
paschk	LD	A,(DE)
	CP	(HL)		;check against what is there now
	JR	NZ,pfail	;go if different data
	INC	HL
	INC	DE
	DJNZ	paschk		;loop for 7 char
notres	LD	HL,ctrl2	;set for reg user (or spcl)
	SET	7,(HL)		;turn on bit flag
	LD	HL,msg7a	;RegSpl
	BIT	6,(IX+74)	;0=reg 1=spl
	JR	Z,notr		;continue if reg
	LD	HL,msg7a+3	;else spl user
notr	CALL	cv19		;move for display
	BIT	0,(IX+73)	;check for dropped last time
	JR	Z,notrr		;continue not
	RES	0,(IX+73)	;else they did drop it
	LD	HL,msg18	;drop message
	CALL	out		;send it out
notrr	JP	stats1		;go update stats if user password ok
;
pfail	LD	HL,err2		;invalid password
	CALL	out
	CALL	adderr		;decrement the tries allowed
	OR	A		;0=too bad bye!
	JP	NZ,repas	;and try again
badlog	LD	HL,err3		;else BOOT!
	CALL	out		;send out
	JP	hbort0		;and exit with him in tow
;
newusr	LD	HL,ctrl2	;set flag for new user
	SET	6,(HL)		;show a new user
	LD	HL,8002H	;look for blank for name storage
	CALL	cv6		;get total users/offset
	CALL	fndspt		;go find blank spot
	JR	Z,uspot		;go if users spot found
	LD	HL,tusr+2	;else use temporairly holding spot
uspot	DEC	HL		;backup 2
	DEC	HL
	LD	(usradd),HL	;save user address for info
	LD	HL,1		;start by looking through all #'s
	LD	BC,(maxusr)	;get total users allowed
uloop	LD	(val3),HL	;for empty one
	PUSH	BC		;save counter
	CALL	fndusr		;see if number in VAL3 is used
	POP	BC		;else get back counter 1-maxusr
	JR	NZ,unused	;go if number is valid
	LD	HL,(val3)	;get last number
	INC	HL		;add 1 to total
	CALL	cv23		;DEC BC
	JR	NZ,uloop	;loop from 1-MAXUSR for unused #
	LD	HL,999		;else set to 999 (system full)
	JR	urdone		;and then continue
unused	LD	HL,(val3)	;get number unused at present
urdone	CALL	gua		;LD IX,(USRADD)
	CALL	svix01		;insert LSB/MSB number
	PUSH	IX
	POP	HL
	INC	HL
	INC	HL
	LD	BC,75		;bytes to erase -1
	CALL	erase		;fill with zeros
entpas	LD	HL,q3		;define a password
	CALL	out
	LD	HL,buffer+20	;where to get it first time
	LD	A,7
	CALL	uinput		;upper case password
	LD	A,(inexit)	;see if we want him off
	OR	A		;Z=bug off
	JP	NZ,lostcd	;drop him if F2 pressed
	CALL	cd		;check CD
	JR	Z,epas0		;continue if still cd
	CALL	erause		;and erase the user
	JP	lostcd		;and back to main routines
epas0	CALL	cv18		;check length of input
	JR	Z,entpas	;do password again
	LD	DE,(usradd)	;now we know who and password so store
	PUSH	DE		;save pointer
	INC	DE		;point past user number
	INC	DE
	LD	HL,buffer	;and then block move 16 char
	LD	BC,16
	LDIR			;copy name to line info
	POP	HL		;get back pointer
	PUSH	HL		;save for installing defaults
	LD	DE,21		;offset to password
	ADD	HL,DE
	EX	DE,HL		;move destination to DE
	LD	HL,buffer+20	;where to read characters from
	LD	BC,7		;bytes to copy out
	LDIR			;and do it
	POP	HL		;HL=user address
	PUSH	HL		;save it again
	LD	DE,73		;offset to bit control
	ADD	HL,DE
	PUSH	HL
	POP	IX
	LD	HL,default
	LD	B,3		;bytes to install
instal	LD	C,(IX)		;get current values
	LD	A,(HL)		;get default value
	OR	C		;mask out
	LD	(IX),A		;save result
	INC	HL
	INC	IX
	DJNZ	instal		;loop for 3 characters
	POP	IX		;ix = users address
	LD	A,(defbrd)	;get number of boards allowed on
	LD	(IX+37),A	;insert in routine
	LD	A,(defbrd1)	;get MSB type
	LD	(IX+38),A	;insert in case
	LD	HL,msg7		;New
	CALL	cv19		;move for display
stats1	LD	HL,online	;set flag for users name
	SET	6,(HL)		;so we know who he is
	CALL	date		;format date to buffer
	LD	HL,(usradd)	;get user address
	INC	HL
	INC	HL		;point to name
	LD	DE,ustat+7	;point to name field
	LD	B,16		;bytes to move
	CALL	fmtcr		;and copy/purge cr from line
	LD	HL,uname0	;point to source to move
	LD	DE,uname	;point where to move it to
	LD	BC,8		;total length to move
	LDIR			;and do it
	LD	HL,dbuff	;point to date
	LD	DE,ustat+40	;offset to buffer
	LD	B,5
	CALL	fmtcr
	LD	HL,msg6		;last on data
	CALL	out		;send it out
	LD	HL,(usradd)	;get user address
	LD	DE,18		;offset to date
	ADD	HL,DE
	PUSH	HL		;else save pointer
	LD	A,(HL)		;0=new NZ=previous
	OR	A		;check
	JR	Z,stat2		;go if new user
	CALL	cv25		;convert date
	JR	stat3		;and continue
stat2	LD	HL,msg7		;new user
stat3	CALL	out		;send it out
	POP	HL		;get back location of date
	CALL	cv26		;convert and move
	LD	HL,tbuff	;time buffer
	LD	A,@time
	RST	svc
	LD	DE,ustat+51	;offset to use
	LD	HL,tbuff
	LD	BC,5		;move 5 characters
	LDIR
	CALL	gua		;LD IX,(USRADD)
	CALL	rdix01		;get users number LSB/MSB
	PUSH	HL		;save it for later
	LD	DE,ustat	;where to store the number
	CALL	bindec		;convert to DECIMAL
	CALL	u2scr		;user stats to video
	POP	HL		;HL=users number LSB/MSB (save it after)
	LD	A,(ctrl)	;turn on the bell
	BIT	5,(IX+73)	;see if bell wanted
	JR	Z,nobel		;skip if bell signal off
	SET	5,A		;turn it on
	JR	dmbel		;and continue
nobel	RES	5,A		;turn off bell
dmbel	LD	(ctrl),A	;save results
	LD	(usrnum),HL	;and save instead of checking
	LD	(newnm),HL	;save at this time
	LD	DE,999		;see if temp user first
	OR	A		;clear the carry
	SBC	HL,DE		;=Z if temp user
	JR	NZ,notemp	;go if normal user
	RES	3,(IX+74)	;not allowed to leave msgs
notemp	LD	L,(IX+35)	;get total calls from him
	LD	H,(IX+36)
	INC	HL
	LD	(IX+35),L	;and then insert back in
	LD	(IX+36),H
	PUSH	IX
	CALL	pram1		;set user parameters
	POP	IX		;get back user address
	CALL	ckol		;check hl for online
	JR	NZ,usok		;allow master sysop bypass
	BIT	2,(IX+73)	;0=normal user 1=restricted
	JR	Z,usok		;go if he's allowed on
	LD	H,0h		;some error location (bogus)
	LD	A,R		;pick random start
	LD	L,A		;move it
	LD	B,60		;send some garbage first
hack22	LD	A,(HL)		;get a byte
	CALL	sbyte		;send to modem only
	INC	HL
	DJNZ	hack22		;loop til junk is sent
	LD	HL,err4		;bye bye msg
	CALL	out		;send out
	JP	hbort		;else just high and goodbye
usok	LD	A,(tmflag)	;see if master time set
	OR	A		;1=all have time limit
	JR	Z,usok0		;go if individual control
	LD	A,(stime)	;get master system time value
	LD	(tmax),A	;insert in routine
	JR	usok1		;and continue
usok0	LD	A,(utime)	;get time alloted for user
	LD	(tmax),A	;insert in timer routine
	LD	A,(IX+73)	;0=no time line 1=time limit imposed
	AND	64		;mask out other bits
usok1	LD	(tcheck),A	;will be 0, or NZ
	CALL	dspuse		;show users
	CALL	addbrd		;add 1 to board caller count
	CALL	countu		;count users
	CALL	calbrd		;then update stats
	CALL	gba		;LD IX,(brdadd)
	CALL	rdix01		;read LSB/MSB
	LD	DE,clnum	;where to store number
	CALL	bindec		;convert to DEC ASCII
	LD	HL,msg46	;Caller Number
	CALL	out		;send it out
	CALL	addtot		;increase total board callers by 1
;
	CALL	ckol		;Z=remote, NZ=local
	JR	Z,notrem	;if remote check for local sysop
	LD	HL,0		;else its from keyboard remove count
	JR	dip		;and continue
notrem	LD	HL,(logger)	;get total callers
	INC	HL
dip	LD	(logger),HL	;else add 1 to total
	CALL	curon		;turn on cursor
;
