	PAGE
;Complete Modem Control for FastPlus II
;Copyright 1988 by Mel Patrick
;Filename - MDMCTRL/ASM
;
mdinit	LD	A,(modem)	;get modem type bits (0-7)
	AND	4		;mask out, check for Modem II
	RET	NZ		;back if it is in use
	LD	HL,usrdef	;else point to modem string
setmdm	LD	A,(HL)		;get byte
	CP	'_'		;pause command
	JR	Z,dopaws	;wait for 2 seconds then
	CP	3		;eof line
	JR	Z,allset	;go if setup
	CP	'\'		;want a c/r?
	JR	NZ,nocr		;skip if not
	LD	A,13		;else we want one
nocr	CALL	sbyte		;else send byte to modem
nocr0	INC	HL		;point to next
	LD	BC,1000H	;slow the sending rate down
	CALL	waste
	JR	setmdm		;loop til all sent
dopaws	CALL	delay2		;delay 2 seconds
	JR	nocr0		;and re-enter routine
	RET			;and go back
;
allset	CALL	clrtyp		;empty buffer
	RET			;and go back
;
discon	CALL	cvtime		;calculate connect time
	LD	HL,ustat	;point to user stats
	LD	DE,buffer	;where to move it to
	LD	BC,78		;bytes to move
	LDIR			;and move them for printing
	CALL	retime		;reset key input timer
	CALL	ckola		;Z=remote, NZ=local keyboard
	JR	NZ,disc1	;continue if sysop control
cdon	LD	A,(modem)	;see what kind of modem first
	AND	195		;check bits 0,1,6,7
	JR	Z,disdtr	;if Z, use DTR only, +++ not avail
	LD	A,(track)	;see if escape wanted
	BIT	3,A		;Z=DTR , NZ=ESCAPE
	JR	Z,disdtr	;go if DTR only
	LD	HL,offcode	;point to off codes
	CALL	setmdm		;reset modem to off
	JR	dischk		;and check to make sure its off
disdtr	LD	A,7		;toggle DTR
	OUT	(0EAH),A	;to off condition
	CALL	delay2		;wait 2 second to lose connection
	CALL	stbaud		;enable DTR again
	CALL	delay1		;wait after enabling
dischk	CALL	carrier		;see if carrier still online
	JR	NZ,cdon		;else if different, still have a cd
disc1	CALL	delay1		;wait 1 second
	LD	HL,ctrl		;check for 300/1200
	BIT	3,(HL)		;Z=300 only NZ=1200/300
	JR	Z,disc3		;if only 300 then only use it
	SET	6,(HL)		;else toggle back to 1200 as default
disc3	CALL	stbaud		;set the baud rate back to default
	CALL	delay1		;wait a second
	LD	A,(modem)	;check for Modem II
	AND	4		;mask to check for Modem II
	JR	Z,disc0		;continue if not modem II
	CALL	ckola		;Z=remote, NZ=local keyboard
	JR	NZ,disc0	;skip sending C's if local
	LD	HL,usrdef	;else reset code
	JP	setmdm		;sent modem and ret
disc0	JP	mdinit		;reset all modems now, and ret
;
stbaud	LD	A,1		;reset current baud rate
	OUT	(0E8H),A
	LD	HL,ctrl		;point to control
	BIT	3,(HL)		;0=300, 1=1200
	JR	Z,do300a	;go if only 300 avail
	BIT	6,(HL)		;else test for current rate
	JR	Z,do300a	;Z=set to 300, NZ=set 1200
	SET	6,(HL)		;else its 1200
	LD	A,(track2)	;see if 2400 UART wanted
	BIT	4,A		;bit 4 Z=no, NZ=yes
	JR	NZ,do2400	;go if we want 2400
do1200	LD	A,77H		;set 1200
	LD	C,'H'		;1200
	JR	doset		;and 
do300a	RES	6,(HL)		;set for 300 now
do300	LD	A,55H		;300 baud
	LD	C,'L'		;300
doset	OUT	(0E9H),A	;setup
dtron	LD	A,(wsp)		;get word stop parity to use
	OUT	(0EAH),A	;setit
	LD	A,C		;get rate
	LD	(ustat+77),A	;insert in users info
	LD	(title+78),A	;save in title too
	PUSH	HL		;save pointer
	LD	HL,78		;where to display it
	CALL	bdisp		;display it
	POP	HL		;restore pointer
	RET			;and go back
;
do2400	LD	A,0AAH		;2400 baud
	LD	C,'U'		;2400 ultra
	JR	doset		;set and return
;
baudsw	LD	HL,ctrl		;get control byte
	BIT	3,(HL)		;0=300 baud only
	RET	Z		;back if only 300 allowed
	LD	A,(HL)		;else get the byte
	XOR	64		;toggle 300/1200 bit
	LD	(HL),A		;save new status
	JR	stbaud		;then reset baud rate
;
hoff	DM	'ATS0=0',13,3	;turn off Auto Answer on Hayes
offcode	DM	'_~~~_ATH',13,3	;disconnect from some modems
;
