;Message editing module
;INCLUDE file in the MSGENT/ASM module
;Copyright 1988 by Mel Patrick
;Filename - MSGEDIT/ASM
;
edmsg	LD	HL,msg51	;Line # to edit
	CALL	gtnum0		;print the message and get line#
	JP	NZ,pedit	;back if invalid input
	LD	B,C		;move line number to B
	LD	A,(msglin)	;get total lines allowed
	CP	B		;if B>A then abort
	JP	C,pedit		;back if out of range
	LD	HL,buffer+38	;start of message buffer
	LD	A,B		;better check for first line
	CP	1		;want first line?
	JR	Z,fed0		;go if edit of line 0 wanted
	DEC	B		;else minus 1 from counter for line
fed	LD	A,(HL)		;look for end of marker before line
	CP	0FFH		;marker means you can't edit
	JP	Z,cent		;if last line edit, use continue
	CALL	lstep		;and step to proper line
	DJNZ	fed		;and loop til line found
	LD	A,(HL)		;check for last line edit
	CP	0FFH		;if last line edit, then use continue
	JR	Z,fed		;use exit in this routine to get to sub
fed0	LD	(val1),HL	;save line position we are going to edit
	CALL	lower		;switch in lower case
	LD	HL,msg52	;LINE DID READ :
	CALL	out		;send it out
	CALL	mvedln		;move the line to edit
backss	DEC	DE		;back til no spaces
	LD	A,(DE)		;look for NON space
	CP	0DH		;or C/R
	JR	Z,bkcr		;go if we already have an end
	CP	' '		;else is it a space
	JR	Z,backss	;continue til ASCII found
	INC	DE		;else add 1 and insert CR
bkcr	LD	A,0DH		;mark the end character
	LD	(DE),A		;insert for editing
list	CALL	cret		;do a c/r
	LD	HL,dummy+1	;then print the line
	CALL	showed		;show line we are editing
edolp	LD	HL,msg53	;EDIT commands
	CALL	out		;send it out
	CALL	dorule		;send out ruler
	CALL	cret		;do a c/r
	LD	B,3		;and tab in
	CALL	prule		;tab in 3 spaces
	LD	A,'>'		;then a > sign
	CALL	output		;send to remote
	LD	HL,dummy+1	;start of edit line
edkey	XOR	A		;move temp var
	LD	(temp),A	;incase of insert
	CALL	inkey		;wait for a key
	CP	' '		;NEXT CHARACTER
	JR	Z,nxtchr	;go if yes
	CP	8		;backspace?
	JR	Z,edback	;go if yes
	CP	' '		;see if too low
	JR	C,edkeya	;continue if yes
	AND	5FH		;convert to upper case
	CP	'E'		;END edit?
	JP	Z,edcd		;go if yes
	CP	'D'		;DELETE CHAR
	JP	Z,delchr
	CP	'C'		;CHANGE CHAR
	JR	Z,change
	CP	'I'		;INSERT CHARS
	JP	Z,insert
	CP	'H'		;HACK
	JR	Z,hack
	CP	'L'		;LIST the LINE
	JR	Z,list		;go if yes
	CP	'X'		;extend?
	JR	Z,xtend
	CP	'A'		;abort editing
	JP	Z,edabrt	;forget it if yes
edkeya	CALL	cd		;else check cd
	JP	NZ,hbort	;carrier lost
	JR	edkey		;else loop
;
nxtchr	CALL	ckedcr		;look for end of line
	JR	Z,edkey		;back if end of line
	CALL	output		;else print single character
toofar	INC	HL		;point to next
	JR	edkey		;and back for more
;
edback	DEC	HL		;back up
	LD	A,(HL)		;check for start of line
	OR	A		;Z=start of line
	JR	Z,toofar
	LD	A,8		;else backspace
	CALL	output		;send to remote
edkeyb	JR	edkeya		;and continue
;
delchr	CALL	ckedcr		;look for end of line
	JR	Z,edkey		;back if found
	PUSH	AF		;save it
	LD	A,'\'		;backslash
	CALL	output
	POP	AF		;get back character to remove
	CALL	output		;send it out
	LD	A,'\'		;backslash again
	CALL	output
	CALL	shrink		;and shrink the line by 1
	JR	edkeyb		;and back
;
change	CALL	ckedcr		;see if end of line
	JR	Z,edkeyb	;back if yes
	CALL	inkey		;else wait for a key
	CP	' '		;if less forget it
	JR	C,edkeyb	;back if too low
	LD	(HL),A		;else insert in string
	JR	nxtchr		;and display it
;
xtend	CALL	ckedln		;see if line is full
	JR	Z,edkeyb	;back if line is full
	CALL	ckedcr		;see if end of line
	JR	Z,hack		;go if yes
	CALL	output		;else print char
	INC	HL		;point to next
	JR	xtend		;and loop til CR found
;
hack	LD	(HL),0DH	;insert new end marker
;
insert	CALL	ckedln		;see if line is full?
	JR	Z,edkeyb	;back if line is full
edinlp	CALL	inkey		;wait for a key
	CP	0DH		;enter?
	JP	Z,edkeya	;exit insert and continue
	CP	8		;else backspace?
	JR	NZ,notbck	;go if not backspace
	LD	A,(temp)	;see if anything there
	OR	A		;Z=nothing
	JR	Z,nochars	;go if no chars typed in
	DEC	A		;else back up one
	LD	(temp),A	;save it
	DEC	HL		;back up in buffer
	CALL	shrink		;move string back one
	LD	A,8		;then backspace on video
	CALL	output		;now
	JR	nochars		;and check CD
;
notbck	PUSH	HL		;save
	PUSH	HL		;twice
	POP	DE		;then move to DE
	LD	HL,dummy+128	;this gets changed to an address
	OR	A
	SBC	HL,DE		;find size to move
	PUSH	HL		;move to BC
	POP	BC		;BC=size now
	LD	HL,dummy+127	;change this to END -1
	LD	DE,dummy+128	;change to END
	LDDR			;and move them apart now (INSERT)
	POP	HL		;restore where character is
	LD	(HL),A		;insert character
	INC	HL		;point to next
	CALL	output		;send to video
	LD	A,(temp)	;add 1 for this char
	INC	A
	LD	(temp),A	;save in case of backspace
nochars	CALL	cd		;see if carrier lost
	JR	NZ,edcd		;continue if cd lost
	JR	insert		;back if CD still online
;
edabrt	CALL	mvedln		;copy back original line first
;
edcd	LD	A,(msgflg)	;CALLed from MAIL routine
	OR	A		;Z=no, NZ=yes
	JR	Z,fed1		;skip if not
	CALL	cd		;else check for carrier
	RET	NZ		;back if lost
	JR	fed2		;else skip the other check
fed1	CALL	cd		;check for carrier
	JP	NZ,hbort	;exit if he is gone
fed2	LD	A,(len1)	;else get length entered
	OR	A		;0=blank line
	JP	Z,pedit		;back if left alone
	LD	HL,dummy+1	;else point to line entered
	LD	DE,(val1)	;get destination
	CALL	copyln		;and copy the line back
	JP	pedit		;altered and saved now
;
showed	CALL	tabed		;move in 4 spaces
	LD	A,(linel)	;get line length
	LD	B,A		;used for display loop
	CALL	fmtnam		;and format it to the video display
	RET			;and go back
;
ckedcr	LD	A,(HL)		;get char
	CP	0DH		;look for CR
	RET			;back with flags set
;
shrink	PUSH	HL		;save pointer
	LD	C,0		;set counter
fndend	CALL	ckedcr		;see if a C/R here
	JR	Z,fedcr		;go if found
	INC	HL		;point to next char
	INC	C		;add 1 to counter
	JR	fndend		;loop til found
fedcr	POP	HL		;get back pointer
	PUSH	HL
	POP	DE		;setup for move
	PUSH	DE		;save
	INC	HL		;source higher than dest.
	CALL	copyll		;copy back to original
	POP	HL		;restore pointer
	RET			;and back to caller
;
mvedln	LD	HL,(val1)	;get original line
	LD	DE,dummy	;where to move it to
	XOR	A		;zero out A to set marker
	LD	(DE),A		;save it
	INC	DE		;DE=BUFFER + 1
copyln	LD	A,(linel)	;get line length
	LD	C,A
copyll	LD	B,0
	LDIR			;and block move it
	RET			;and go back
;
ckedln	LD	DE,dummy+1	;point to line
	LD	C,0		;count chars
icount	LD	A,(DE)		;get a byte
	CP	0DH
	JR	Z,endstr	;go if end found
	INC	C
	INC	DE		;else add
	JR	icount
endstr	LD	A,(linel)	;get line length
	CP	C		;see if FULL line
	RET			;Z=FULL, NZ=we have room
;
