	PAGE
;Subroutines for FastPlus
;May be used by more than 1 routine
;Filename - SUB/ASM
;
;SETML  : RSETML : CRET   : FMTCR  : FMTNAM : COMMA
;FNDUSR : FNDNAM : FNDNUM : DELAY1 : DELAY2 : HOTLIN
;CHKSYS : INKEY  : SCAN   : CHKREM : REUPDT : CREDITS
;CLRENT : RTIME  : RESVID : CKROOM : PRAM1  : HOTRET
; HOT   : DOBLINK: HUNT   : DSPNAM : LPRINT : BRDCHK
;CSMARK : DBFILE : PAWS0  : WRSUB  : CLOSEF : WAIT1
;WAIT2  : CTRLX  : RMVFIL : FSPACE : MVTHFL : MVFL
;MVFL0  : MVFL1  : CRFCB  : ADDEXT : FLOPEN : FLINIT
;MVIT   :SPCLSND : SNDTAB : BINDEC :  PUT   :  GET
;PRT    : COUNTU : COUNTD : MYBEEP : ADDSUB : QTEST
;SETTRY : ERAUSE : P2PW   : THDATE : RERATE : SVRATE
;MAILCK : CPHLDE : MCFOFF : MUSUB  : MUADD  : FPUT
; FGET  : FCPUT  : PEOF   : WRITE  : THAYES : TSTMDF
;DLUPD  : GTUPDR :
;
setml	LD	A,37H		;SCF op code
setml0	LD	(setres),A	;insert in subroutine
	JR	stset		;and start routine
rsetml	LD	A,0B7H		;OR A (clears the carry flag)
	JR	setml0		;and continue
stset	LD	A,(board)	;get board are in
	CP	9		;check for byte to use
	JR	C,lbrd		;go if lower boards in effect
	SUB	8		;else subtract 8 (make it 1-8)
	LD	B,A		;move to loop counter
	LD	A,(IX+40)	;but use second location for work
	JR	dorot		;and do a rotate
lbrd	LD	B,A		;using boards 1-8 (lower)
	LD	A,(IX+39)	;so use first location
dorot	PUSH	BC		;save counter for moving back in
	OR	A		;clear the carry in case
dorot0	RRA			;rotate bit out to the carry location
	DJNZ	dorot0		;then set or RESET it as needed
setres	NOP			;either OR A or SCF to clear or set
	POP	BC		;get back counter now
dorot1	RLA			;and rotate it back in
	DJNZ	dorot1		;continue until restored
	LD	C,A		;then save the value
	LD	A,(board)	;check board in use
	CP	9		;find byte location to save new pattern
	JR	C,lbrd0		;go if using lower 8 bits
	LD	(IX+40),C	;else insert in upper boards
	RET			;and go back all done
lbrd0	LD	(IX+39),C	;save in lower boards position
	RET			;and then go back
;
;Finding Subroutines for Fastplus
;
hunt	LD	HL,buffer+1	;point to where to start search
	CALL	decbin		;convert to number
	LD	(val3),BC	;save it
;
; use the RET in fndusr to go back to caller
;
fndusr	CALL	bank1		;select users bank
	LD	HL,(val3)	;check for ALL
	INC	HL		;add 1 (FFFFH for ALL)
	LD	A,H
	OR	L		;0=ALL
	JR	NZ,fcont	;continue if not all
	LD	HL,msg41-2	;else point to ALL
	JR	fndall		;found msg to ALL
fcont	CALL	cv6		;BC=maxusrs, DE=offset
	LD	HL,8000H	;start of users search
fulp	PUSH	HL		;move to IX for checking
	POP	IX
	LD	A,(IX+2)	;test for any ASCII name
	OR	A		;if zero, end of list
	JR	Z,fn0		;if no match, loop for MAXUSRs
	LD	A,(val3)	;else check number against this one
	CP	(IX)		;check LSB first
	JR	NZ,fn0		;continue if not same
	LD	A,(val3+1)	;else match LSB, check MSB
	CP	(IX+1)		;check against this one
	RET	Z		;back HL=user data address
fn0	CALL	addsub		;add hl,de, dec bc
	JR	NZ,fulp		;loop til end or found
nousr	LD	HL,msg38-2	;USER DELETED
fndall	JP	nonum		;set NZ flag
;
fndnum	CALL	bank3		;select working bank
	LD	HL,8000h	;else start of msg bank
mflp	PUSH	HL		;move to index reg
	POP	IY		;use IY for this
	LD	A,(HL)		;check for no msg
	OR	A		;0=end of file
	JR	Z,fndall	;go if not found (set NZ flag)
	LD	L,(IY+5)	;get LSB of current msg number
	LD	H,(IY+6)	;get MSB of same
	LD	DE,(val2)	;get msg number to look for
	CALL	cphlde		;see if a match
	JR	Z,mnfnd		;go if msg number found
	LD	A,(mflag)	;else test for <> stuff
	OR	A		;0=skip 1=do it
	JR	Z,nrf		;continue if not in Forward ret mode
	CALL	cphlde		;else check for HL>DE
	JR	NC,mnfnd	;go if we start here
nrf	PUSH	IY		;move HL pointer back to start of msg
	POP	HL		;for offset to next
	LD	E,(IY+3)	;get length of current msg
	LD	D,(IY+4)	;"	"
	ADD	HL,DE		;point HL to start of next msg
	JR	mflp		;loop til end or not found
;
mnfnd	LD	(msgadd),IY	;save address of msg
	CP	A		;set Z flag
	RET
;
fndnam	CALL	bank3		;select msg bank
	LD	HL,8000H	;start of memory bank
fndn0	PUSH	HL		;move to index
	POP	IY		;use IY
	LD	A,(HL)		;get a byte (YY in date)
	OR	A		;0=end of file
	JP	Z,fndall	;set NZ flag and return
	CALL	musub		;check user number against header
	JR	NZ,nonm		;continue if no match
	LD	A,(mcf)		;see if CALL from MAILCK
	OR	A		;Z=no, NZ=yes
	RET	Z		;back if from MSGENT
	LD	A,(IY+7)	;else see if you have READ it
	BIT	2,A		;Z=not read YET, NZ=YES it was read
	RET	Z		;back if he has one not read yet
nonm	CALL	muadd		;add HL and DE to get next location
	JR	fndn0		;loop til something or end
;
sndtab	LD	A,9		;send out a TAB char
	JR	comma0		;do it
;
comma	LD	A,','		;do a comma
comma0	CALL	output		;send it out
	RET			;and go back
;
cret	LD	A,13		;do a c/r
	JR	comma0		;do it and return
;
crsub	CALL	cret		;do a c/r
	CALL	cret		;and another
	RET			;and then go back
;
kcr	LD	DE,buff2	;where to format it
	PUSH	DE		;save for return
	CALL	fmtcr		;get rid of c/r in line
	LD	A,3		;insert end marker
	LD	(DE),A		;so we can mark end of line
	POP	HL		;HL=address of data to print
	RET			;and then go back
;
fmtcr	LD	A,(HL)		;get byte
	CP	13		;purge c/r
	JR	NZ,nofmt	;go if not
	LD	A,' '		;else replace with space
nofmt	LD	(DE),A		;insert in buffer somewhere
	INC	HL
	INC	DE
	DJNZ	fmtcr		;loop til done
	RET			;then back
;
spclsnd	PUSH	BC		;save counter
	LD	A,(HL)		;get byte to send
	CP	13		;find a c/r?
	JR	NZ,splsnd	;continue if not
	LD	A,' '		;else replace with a space
splsnd	CALL	output		;send it out
	INC	HL		;point to next
	POP	BC		;B=length to send
	DJNZ	spclsnd		;send for B length, then return
	RET			;back now
;
fmtnam	LD	A,(HL)		;get a byte
	PUSH	AF		;save it
	CALL	output		;print result
	POP	AF		;get back character
	CP	13		;if C/R then ret, as we are done
	RET	Z		;back if yes
	INC	HL		;else point to next
	DJNZ	fmtnam		;loop for max characters
	LD	A,13		;else do a c/r
	CALL	output		;send it out
	RET			;then go back anyways
;
xmpaws	LD	BC,5000H	;delay for 292ms
	JR	delpaw		;and delay
delay2	LD	BC,0
	CALL	waste		;waste some time
delay1	LD	BC,0
delpaw	CALL	waste
	RET
;
hotlin	LD	A,(HL)		;get a byte
	PUSH	AF		;save it
	CALL	output		;send out character
	POP	AF		;get back char
	CP	13		;c/r end of line
	RET	Z		;back if yes
	PUSH	BC		;save counter
	CALL	scan		;else check for key input
	POP	BC		;then get it back
	JR	NZ,hotl0	;continue if nothing
	CP	'P'		;else pause?
	JR	Z,dopws		;go if yes
	CP	'A'		;else ABORT?
	JR	NZ,nabrt	;skip if not abort
	SCF			;else set carry flag
	RET			;and go back now
nabrt	CP	'S'		;else SKIP (NEXT)
	RET	Z
	CP	'N'		;else NEXT
	RET	Z		;back if yes
	LD	C,A		;save character
	LD	A,(spclkl)	;else test for special kill
	OR	A		;Z=not enabled, NZ=enabled
	JR	Z,hotl0		;continue if off
	LD	A,C		;else get back key value
	CP	A		;set Z flag (81 or 82)
	RET			;and go back
hotl0	INC	HL		;else point to next char
	DJNZ	hotlin		;loop til all printed
	RET			;and then go back
dopws	PUSH	BC		;save counter
	CALL	doblink		;see if blink wanted
	CALL	scan		;check for incoming
	POP	BC		;restore it
	JR	Z,hotl0		;continue if character rec
	PUSH	BC		;save count again
	CALL	cd		;check for carrier
	POP	BC		;restore it again
	RET	NZ		;back if carrier dropped
	JR	dopws		;else continue to loop
;
chksys	CALL	ckola		;Z=remote, NZ=local
	RET	NZ		;back if sysop at keyboard
	LD	A,(vidpas)	;see if active editing
	OR	A		;Z=no, NZ=yes
	RET	NZ		;back if active editing
	CALL	bank1		;select users bank
	CALL	b7ix75		;NZ=master, Z=who knows
	RET			;and back with it
;
chkre0	LD	E,0		;check byte 0
	JR	chkrem		;and do it
chkre1	LD	E,1		;check byte 1
	JR	chkrem		;and do it
chkre2	LD	E,2		;and check byte 2
chkrem	PUSH	BC		;save bit postion first
	CALL	bank1		;select bank1
	POP	BC		;get back in case
	CALL	b7ix73		;Z=normal, NZ=remote sysop
	RET	Z		;back if none
	LD	HL,sysopt	;else see if he has access to option
	LD	D,0		;code to look at in E
	ADD	HL,DE		;DE=offset to byte
	LD	A,(HL)		;get the control byte
	AND	C		;C=mask value to check (1 bit)
	RET			;and go  back
;
dsrch	CALL	bank2		;select download bank
	LD	HL,8003H	;start of entry
	LD	BC,(maxdwn)	;get maximum downloads available
	LD	DE,80		;bytes for offset
	LD	A,12		;match length
	JR	search		;and look for match
usrch	LD	HL,8002H	;start of search
	CALL	cv6		;BC=maxusrs, DE=offset
	LD	A,16		;and bytes to match
search	LD	(slen+1),A	;save search length
srchlp	PUSH	HL		;move for checking (uses index regs)
	POP	IY
	LD	IX,(data)	;point to original data to check
	PUSH	BC		;save counter
slen	LD	B,0		;length of search
srch0	LD	A,(IX)		;get byte in buffer
	CP	(IY)		;check against whats in memory
	JR	NZ,srch1	;skip if different
	INC	IX		;else its the same so far
	INC	IY		;so check next bytes
	DJNZ	srch0		;loop for total length
	POP	BC		;fix the loop counter
	DEC	HL		;always back up 2
	DEC	HL		;in case we need it
	CP	A		;set the zero flag HL=address
	RET			;and go back
srch1	POP	BC		;get back counter
	CALL	cv23		;dec bc
	JP	Z,nonum		;go if search failed (NZ)
	ADD	HL,DE		;else step to next user location
	JR	srchlp		;and continue to search
;
inkey	PUSH	HL		;save pointer
	CALL	ckol		;see if SYSOP in local mode
	JR	NZ,inkey0	;continue if local mode
	BIT	4,(HL)		;dropped CD bit
	JR	Z,inkey0	;continue if still cd
	POP	HL		;else back we go
	LD	A,13		;insert a c/r
	CP	A		;set Z flag
	RET
inkey0	POP	HL		;get back pointer
	CALL	scan		;scan for input
	RET	Z		;back if character received
	JR	inkey		;else loop back for more
;
scan	LD	A,(keypas)	;test for bypass in RS232 routine
	OR	A		;Z=normal NZ=bypass
	JR	NZ,scanky	;skip if bypassing
	CALL	ckola		;Z=remote, NZ=keyboard
	JR	NZ,scanky	;don't bother with RS232 if not on
	CALL	rdbyte		;scan incoming rs232
	JR	NZ,scanck	;check keyboard if no RS232 input
	PUSH	AF		;save it
	XOR	A		;remove count
	LD	(timeout),A	;save it
	POP	AF		;and the continue
scant	CALL	rtime		;reset timer routine (totally)
	CP	A		;set Z flag
	RET			;and go back
scanck	LD	A,(ctrl2)	;test for key timeout routine enable
	BIT	2,A		;Z=off, NZ=on
	JR	Z,scanky	;skip if off
	LD	DE,(ktimer)	;get timer value
	DEC	DE		;minus 1 from it
	LD	(ktimer),DE	;save it
	LD	A,D
	OR	E		;check for time out error
	JR	NZ,scanky	;continue if not timed out
	CALL	retime		;reset master 30 second timer
	LD	A,(ksec)	;get current loop counter
	DEC	A		;minus 1 from loop
	LD	(ksec),A	;save it
	OR	A		;Z=all timed out
	JR	NZ,scanky	;skip if not timed out
	LD	A,(track2)	;test a bit
	BIT	3,A		;Z=normal, NZ=disconnect if timeout
	JR	Z,disdon	;continue if normal
	LD	A,(timeout)	;see if at MAX
	INC	A		;add 1
	LD	(timeout),A	;save it
	CP	2		;if 2, then disconnect
	JR	NZ,nodis	;continue if not full
	CALL	discon		;disconnect if yes
	JR	disdon		;and continue
nodis	PUSH	HL		;else save pointer
	PUSH	BC		;save "	"
	LD	HL,ABSPAT	;error message
	CALL	out		;send it out
	POP	BC
	POP	HL		;and continue
disdon	LD	A,13		;else setup for a ret
	JR	scant		;and continue
scanky	CALL	kbd		;else scan keyboard
	RET	NZ		;back if nothing
	CP	3		;else ctrl C
	JR	Z,ctrlc
	CP	17		;ctrl Q
	JR	Z,ctrlq
	CP	19		;ctrl S
	JR	Z,ctrls
scanex	CP	A		;set the Z flag for char
	RET			;and go back
ctrlc	LD	A,'A'		;abort code
	JR	scanex
ctrlq	LD	A,'Q'		;resume
	JR	scanex
ctrls	LD	A,'P'		;pause command
	JR	scanex
;
rtime	PUSH	AF		;save any characters
	LD	A,(keysec)	;get normal counter
	LD	(ksec),A	;insert for next time
	POP	AF		;then restore them
retime	LD	DE,(tmout)	;get timeout value allowed
	LD	(ktimer),DE	;insert in routine
	RET			;and back to caller
;
disvid	LD	A,1		;disable video
	JR	resvd0		;do it
resvid	XOR	A		;restore video/keyboard route
resvd0	LD	(vidpas),A	;save it
	LD	(keypas),A	;"	"
	RET			;and back to menu/termin
;
clrent	CALL	bank2		;select download menu bank
	LD	HL,(val1)	;point to data entry location
	LD	BC,79		;bytes to erase -1
	CALL	erase		;clear them from memory
	RET			;and then back to download section
;
credits	LD	A,(tmin)	;get current time
	LD	(tmcred),A	;save it
	RET			;then back to upload routine
;
creditr	LD	A,(sysopt)	;see if restore option alive
	BIT	7,A		;Z=sorry, NZ=yes, restore time
	RET	Z		;back if off
	LD	A,(tmcred)	;else get time before we started
	LD	(tmin),A	;insert in timer
	RET			;and go back
;
reupdt	LD	A,(upd)		;get system update rate
	LD	(update),A	;insert back into counter
	CALL	upnumb		;insert number of update rate
	RET			;and back to caller
;
ckroom	CALL	bank3		;select msg bank
	LD	IY,(brdadd)	;point to data in board address
	LD	DE,8000H	;start of msgs
	LD	BC,0		;set msg counter at zero
ckrm	LD	A,(DE)		;get a byte
	OR	A		;0=no more msgs
	JR	Z,fend		;go if last message found
	PUSH	DE		;else save address
	POP	IX		;and move to index reg
	LD	A,B
	OR	C		;if Z, then save first low#
	JR	NZ,ckrm0	;continue if not zero
	CALL	rdix56		;ld hl with IX+5,6 (LOW MSG#)
	LD	(IY+4),L	;save in BOARD info
	LD	(IY+5),H	;"	"
ckrm0	CALL	rdix56		;LD HL, IX+5,6
	LD	(IY+6),L	;insert in highest number
	LD	(IY+7),H	;for both MSB/LSB
	INC	BC		;add 1 to number in system
	CALL	rdix34		;LD HL, (IX+3,4) (offset to nxt)
	ADD	HL,DE		;point to start of next msg
	EX	DE,HL		;move next location to DE
	JR	ckrm		;loop til 0 found
fend	LD	(msgadd),DE	;save start of new msg
	LD	(IY+2),C	;insert LSB msg counter
	LD	(IY+3),B	;insert MSB count
	CALL	rdiy89		;see if anything here (NXT MSG#)
	LD	A,L		;test for z
	OR	H		;Z=add a number to HIGH msg#
	JR	NZ,numok	;skip if a number is there
numoka	LD	L,(IY+6)	;get HI MSG#
	LD	H,(IY+7)	;MSB and LSB
	INC	HL
	CALL	sviy89		;and save it for new msgs
	JR	numok0		;and skip next check
numok	PUSH	DE		;save for calcs later
	LD	E,(IY+6)	;get LSB high msg
	LD	D,(IY+7)	;get MSB "	"
	OR	A		;clear the carry
	SBC	HL,DE		;if this = zero no good
	POP	DE		;get back next msg pointer
	JR	Z,numoka	;and add 1 to HIGH msg pointer first
numok0	LD	HL,(msgsz)	;DE=msgadd, HL=size of msg
	INC	DE		;add 1 in case of FFFF address
	ADD	HL,DE		;HL points to NEXT LOCATION for msg
	PUSH	HL		;save for later
	PUSH	HL		;move new address to DE first
	POP	DE		;we want to see how much is left
	LD	HL,0FFFFH	;point to TOP of memory
	OR	A		;clear the carry
	SBC	HL,DE		;HL now equals the amount of mem left
	LD	C,0		;set up a counter now
cmsr	LD	DE,(msgsz)	;get message size
	OR	A		;clear the carry
	SBC	HL,DE		;and subtract it
	JR	C,gmsr		;go if we got it
	INC	C		;else add 1 to count
	JR	cmsr		;and loop til done
gmsr	LD	A,C		;get it
	LD	(msr),A		;save it
	POP	HL		;get back pointer and set flags
	LD	A,H		;get MSB address
	CPL			;compliment it
	AND	80H		;check HIGH bits (low now)
	RET			;Z=ok to store, NZ=MEMORY FULL
;
pram1	CALL	gua		;LD IX,(useradd)
	LD	HL,online	;get pointer to user data online
	BIT	3,(IX+73)	;test for CR+LF
	JR	Z,pr0		;go if wanted only cr
	SET	3,(HL)		;else wants a cr+lf
	JR	pr1		;and continue
pr0	RES	3,(HL)		;turn off cr+lf
pr1	BIT	4,(IX+73)	;type of backspace
	JR	Z,pr2		;go if normal one
	SET	1,(HL)		;else need video type backspc
	JR	pr3		;and continue
pr2	RES	1,(HL)		;normal bkspc
pr3	LD	HL,ctrl		;point to second control byte
	BIT	5,(IX+73)	;bell on/off
	JR	Z,pr5		;continue wanted off
	SET	5,(HL)		;else user wants bell
	JR	pr6		;and continue
pr5	RES	5,(HL)		;turn off bell
pr6	RET			;and go back now
;
hotret	LD	A,1		;set for ret without inkey
	LD	(hflag),A	;process later
hot	CALL	vidspl		;special video codes
	LD	A,(HL)		;get a byte
	CP	3		;always ends the messages
	JR	Z,hot1		;continue now
	CALL	output		;else send out character
	CALL	scan		;and do a rs232/keyboard scan
	JR	NZ,nohot	;skip check if no inputs
	CP	'P'		;else want a pause
	JR	Z,paws		;go if yes
	CP	'A'		;abort this function
	JR	NZ,hot3		;continue if not
	XOR	A		;remove ret flag
	LD	(hflag),A	;save it
	LD	A,'A'		;abort and return
	SCF			;else set the carry
	RET			;and go back
nohot	INC	HL		;else point to next char
	JR	hot		;and continue til done
paws	CALL	doblink		;see if * for pause wanted
	CALL	scan		;check for incoming
	JR	Z,nohot		;continue if character rec
	CALL	cd		;check for carrier
	RET	NZ		;back if carrier dropped
	JR	paws		;else continue to loop
hot1	LD	A,(hflag)	;0=continue 1=ret without inkey
	OR	A
	JR	Z,hot2		;continue if flagset
	XOR	A		;else remove flag
	LD	(hflag),A	;save it
	RET			;and go back
hot2	CALL	inkey		;wait for a key or dropped cd
	CP	13		;allow c/r
	JR	Z,hot3		;go if ok
	CP	' '		;else no control characters
	JR	C,hot2		;else just repeat scan
hot3	CP	80H		;look for functions or clr + key
	RET	NC		;if higher, then just return
	PUSH	AF		;else save it
	CALL	output		;print it
	POP	AF		;restore it
	RET
;
doblink	LD	A,(sysopt+1)	;see if blinking splat wanted
	BIT	7,A		;Z=no, NZ=yes
	RET	Z		;back if not
	LD	A,'*'		;else blink it
	CALL	output		;do it
	LD	A,8		;then erase it
	CALL	output		;from screen
	RET			;and go back
;
upnumb	LD	A,(update)	;get current rate
	LD	L,A		;move lsb
	LD	H,0		;remove msb
	CALL	donum		;convert to ASCII
	LD	HL,numbuf+3	;point to number
	LD	DE,msg1a	;where to move 2 digits
	LD	B,2		;counter
	CALL	fmtcr		;copy it out
	RET			;do it
;
trkml	LD	C,A		;move it
	LD	B,A
	CP	9		;see which bits to check
	JR	C,lobrd		;go if board 1-8
	SUB	8		;else make it 1-8
	LD	B,A		;move to loop
lobrd	XOR	A		;remove all flags
	SCF			;set the carry
mlscan	RLA			;shift the carry to board position
	DJNZ	mlscan		;loop for board we are at
	PUSH	AF		;then determine which bit to check
	LD	A,C		;get back board digit
	CP	9		;see if lower or higher
	JR	C,lobrd0	;go if lower set
	POP	AF		;else get back pattern
	AND	(IX+40)		;check board 9-16
	RET			;Z=none here, NZ=got mail in this board
lobrd0	POP	AF		;get back pattern
	AND	(IX+39)		;check lower board
	RET			;Z=no mail, NZ=mail here
;
dspnam	PUSH	HL		;save pointer for ret
	INC	HL		;point past users number
	INC	HL
	LD	B,16		;length of name
	CALL	fmtnam		;send to video
	POP	HL		;restore pointer
	RET			;and go back
;
lprint	LD	A,(ctrl)	;see if printer on line
	BIT	1,A		;test it
	RET	Z		;back if off
	LD	A,@print	;else print HL's line
	RST	svc
	RET	Z		;back if not failed
	LD	A,(ctrl)	;else turn off the option
	RES	1,A		;turn off the bit
	LD	(ctrl),A	;save it
	RET			;and then return
;
brdchk1	PUSH	AF		;save #
	LD	A,38		;check board access for this number
	JR	brdent		;now
brdchk0	PUSH	AF		;save the board we want
	LD	A,40		;Mail Flags (40,39)
brdent	CALL	setix		;set routine to use them
	POP	AF		;get back board number
	JR	brdck		;and start routine
brdchk	LD	A,38		;check BOARD ACCESS (38,37)
	CALL	setix		;set bytes to use in routine
	LD	A,(board)	;get current board
brdck	PUSH	AF		;save it
	CP	9		;if <9 then lower already
	JR	C,selst		;so start with routine
	INC	A		;add 1 for RLA shift
selst	LD	B,A		;and move to loop counter
	XOR	A		;zero out A to start
	SCF			;set the carry flag for rotate
selmsk	RLA			;rotate through the carry flag
	DJNZ	selmsk		;loop for B bits
	LD	B,A		;move to loop for saving
	POP	AF		;get back board we wanted
	CP	9		;see if boards 1-8
	JR	C,sellsb	;go if selecting lower 8 boards
	LD	A,B		;get back pattern
checkm	AND	(IX+38)		;check against MSB of user info
	RET			;Z=not allowed, NZ=allowed
sellsb	LD	A,B		;get back bit pattern
checkl	AND	(IX+37)		;check against LSB board access
	RET			;Z=not allowed, NZ=allowed
;
setix	LD	(checkm+2),A	;insert in routine
	DEC	A		;setup for the LSB
	LD	(checkl+2),A	;insert it
	RET			;back to caller
;
dbfile	CALL	mvfl00		;and copy file to DUMMY
	CALL	pst0		;OPEN the file only!
	JP	NZ,nobull	;go if no bulletins
dbok	CALL	fget		;DE=FBUFF, GET
	JR	NZ,dbdone	;go if done
	CALL	output		;send out single byte
	CALL	scan		;scan for something
	CP	'P'		;want a pause?
	CALL	Z,paws0		;do it if yes
	CP	'A'		;else skip the whole thing?
	RET	Z		;back if yes
	CP	'Q'		;else want to quit?
	RET	Z		;back if yes
	JR	dbok		;else loop for length of bulls
;
dbdone	CP	A		;set Z flag in case
	RET			;and go back
;
paws0	CALL	doblink		;see if blink wanted
	CALL	scan		;see if char received
	RET	Z		;back if yes
	JR	paws0		;else loop for more
;
csmark	LD	A,(smark)	;see if MARKING on/off
	OR	A		;set Z or NZ flags
	RET			;and go back
;
wrsub	LD	HL,buffer	;point to text (BC=size)
rafwr	PUSH	BC		;save counter
	CALL	fcput		;write character to disk (DE=FBUFF) C
	POP	BC
	JR	NZ,wrsube	;exit if write error, don'T close file
	INC	HL		;else point to next
	CALL	cv23		;dec bc
	JR	NZ,rafwr	;loop for BC size
	RET			;and then go back
wrsube	POP	AF		;fix the RET address first
	JP	ercont		;and exit through the error routine
;
closef	LD	DE,fbuff	;close the file
	LD	A,@close
	RST	svc
	RET			;back with flags set
;
wait2	CALL	delay2
wait1	CALL	delay2
	RET
;
ctrlx	LD	A,24		;send a ctrl X
	CALL	sbyte		;send it
	RET			;and continue
;
fspace	CALL	flopen		;open the file only
	RET	NZ		;back if error
rmvfil	LD	DE,fbuff	;else point to filespec
	LD	A,@remov	;and kill it from the disk
	RST	svc
	RET			;and go back
;
mvthfl	LD	HL,(val1)	;get pointer to file
mvit	INC	HL
	INC	HL
mvfl	INC	HL		;step to filename
mvfl00	LD	DE,dummy	;point to where to move it to
mvfl0	LD	BC,12		;bytes to move
	LDIR			;and move it
	RET			;then go back
mvfl1	LD	HL,dummy	;point HL to dummy
	JR	mvfl0		;and do it that way
;
crfcb	LD	DE,fbuff	;create a file
	LD	A,@fspec
	RST	svc
	RET			;go back
;
addext	LD	HL,ext		;add extension
	LD	A,@fext
	RST	svc
	RET			;and go back
;
flopen	LD	A,@open		;use OPEN code
	JR	flstart		;and start that procedure
flinit	LD	A,@init		;else INIT file
flstart	LD	HL,dummy	;now create the file
	LD	DE,fbuff
	LD	B,0
	RST	svc
	RET			;back now
;
ckpack	LD	A,(packet)	;see if 1K packets in effect
	CP	'K'		;K=yes
	RET			;just set flag and go back
;
bindec	LD	A,@bindec	;convert BINARY to decimal
	RST	svc		;at wherever DE/HL are
	RET			;and go back
;
dtsub	INC	HL		;point to next
decbin	LD	A,@decbin	;convert to ASCII
	RST	svc		;now
	RET			;back with value in C
;
kbd	LD	A,@kbd		;quick scan of keyboard
	RST	svc
	RET			;back with character
;
mul16	LD	A,@mul16	;multiply by 16
	RST	svc
	RET			;and back
;
waste	LD	A,@pause
	RST	svc
	RET			;back after pause
;
fcput	LD	C,(HL)		;get byte to write
fput	LD	DE,fbuff	;point to fcb
put	LD	A,@put		;write to DE device
	RST	svc
	RET			;and go back
;
fget	LD	DE,fbuff	;point to file buffer
get	LD	A,@get		;read from DE device
	RST	svc
	RET			;and go back
;
peof	LD	DE,fbuff	;point to file buffer
	LD	A,@peof		;position to end of file
	RST	svc		;do it
	RET			;and just go back
;
write	LD	DE,fbuff	;point to FCB
	LD	A,@write
	RST	svc
	RET			;write 256 to disk file, return
;
prt1c	LD	A,@prt		;and print single char to printer
	RST	svc
	RET
;
thdate	LD	A,@date		;get date to HL
	RST	svc
	RET			;and go back
;
countu	CALL	bank1		;select users bank
	LD	BC,(maxusr)	;get total users
	LD	DE,78		;offset tween users
	LD	A,26H		;insert values for compare
	PUSH	AF
	LD	A,0AH		;and second set
	JR	setmast		;and set them
;
countd	CALL	bank2		;select download bank
	LD	BC,(maxdwn)	;get maximum dl files
	LD	DE,80		;offset tween file entries
	LD	A,01H		;set values for counting
	PUSH	AF		;save it
	LD	A,0CH		;and second set
setmast	LD	(mast3+2),A	;insert in counting routine
	INC	A		;add 1 to value
	LD	(mast4+2),A	;insert in routine
	POP	AF		;get back first values
	LD	(mast1+2),A	;insert in routine
	DEC	A		;minus 1 from count
	LD	(mast2+2),A	;save in routine
	PUSH	BC		;save counter
	CALL	brdpat		;get board bit pattern
	POP	BC		;then restore it
	LD	HL,8000H	;both counts start in bank here
	LD	IX,0		;zero counting flag
uclp	PUSH	HL		;save pointer
	POP	IY		;use IY for checking out data
	LD	A,(IY+3)	;look for some ASCII
	OR	A		;0=no one there, NZ=someone home
	JR	Z,uclp0		;skip counting if no one there
	LD	A,(board)	;now check which byte to test
	CP	9		;check for boards 1-8 (0-7 bit)
	JR	C,ck1		;go if first byte check
	LD	A,(bitpat)	;else we want to check second byte
mast1	AND	(IY+38)		;check second bit pattern
	JR	utest		;use second part for testing
ck1	LD	A,(bitpat)	;else get mask bit
mast2	AND	(IY+37)		;check boards from 1-8
utest	JR	Z,uclp0		;skip if not in mask result
add1u	INC	IX		;else add 1 for this user
uclp0	CALL	addsub		;add hl,de, dec bc
	JR	NZ,uclp		;loop til all counted
	PUSH	IX		;now move total to HL
	POP	HL		;so we can insert in user data
	CALL	gba		;LD IX,(brdadd)
mast3	LD	(IX+10),L	;insert LSB
mast4	LD	(IX+11),H	;insert MSB in total
	RET			;then go back
;
ckol	LD	HL,online	;check online condition
	BIT	0,(HL)		;check it
	RET			;Z=remote, NZ=local
;
ckola	LD	A,(online)	;see if local/remote
	BIT	0,A		;Z=remote, NZ=local
	RET			;set flag ret
;
addsub	ADD	HL,DE		;add HL to DE
cv23	DEC	BC		;then minus 1 from count
	LD	A,B
	OR	C		;and set a flag
	RET			;to check on ret
;
lstep0	LD	HL,(val1)	;used in MSGENT for line pointer
lstep	LD	A,(linel)	;get line length
	JR	lstep1		;and add them and return
;
addsu0	DEC	A		;used for boards
	ADD	A,A		;to get in the table
lstep1	LD	E,A
	LD	D,0		;offset
	ADD	HL,DE		;point HL to location
	RET			;and go back with it
;
mybeep	PUSH	BC		;save counter
	PUSH	AF
	LD	BC,125		;constant
	CALL	delpaw		;@pause
	POP	AF
	POP	BC
	LD	B,C
	RET			;and go back
;
qtest	LD	A,(qflag)	;see if in QUICK SUMMARY
	OR	A		;Z=no, NZ=yes
	RET			;set flag and ret
;
settry	LD	A,10		;see for 10 tries
	LD	(try),A		;save it
	RET			;and go back
;
dspuse	CALL	svrate		;enable fast printing
	LD	B,4		;find cursor FIRST
	CALL	toscr0		;comes back with HL=r/c
	PUSH	HL		;save for last to restore
	CALL	curoff		;turn off cursor now
	LD	HL,0		;set r/c
	CALL	setrc		;set it now
	CALL	disvid		;disable video to RS232
	LD	IX,uname	;point to starting point
	LD	B,5		;display five names
dspulp	PUSH	BC		;save counter of names
	CALL	rdix01		;read in LSB/MSB of user number
	LD	(val3),HL	;save it
	PUSH	IX
	CALL	fndusr		;and find this users name
	POP	IX
	JR	Z,dspu0		;continue if found
	LD	HL,title-2	;else display spaces
dspu0	INC	HL
	INC	HL		;point to name
	LD	B,16		;bytes to show
	CALL	spclsnd		;and display it
	INC	IX
	INC	IX		;step to next number
	POP	BC		;get back counter
	DJNZ	dspulp		;and loop til done
	POP	HL		;get back last cursor address
	CALL	setrc		;reset row/column
	CALL	curon		;turn on cursor
	CALL	resvid		;then enable video output again
	CALL	rerate		;and then restore rate
	RET			;and go back
;
p2pw	LD	HL,(usradd)	;else get user address
	LD	DE,21		;offset to password
	ADD	HL,DE
	LD	B,7		;bytes to show
	RET			;and go back
;
erause	LD	HL,(usradd)	;else remove user data
erausr	LD	BC,77
	CALL	erase		;and remove this users data
	RET
;
svrate	LD	HL,(rate)	;get current rate
	LD	(temp1),HL	;save it
	LD	HL,1		;set to fastest
	LD	(rate),HL	;reset it now
	RET			;and go back
;
rerate	LD	HL,(temp1)	;get original rate
	LD	(rate),HL	;save it
	RET			;and go back
;
mailck	LD	A,1		;set for MAIL CHECKING ONLY
	LD	(mcf),A		;mail check flag
	CALL	fndnam		;look for users mail
	CALL	mcfoff		;turn off option
	JR	NZ,rtm		;go if nothing was found
	CALL	bank1		;else get users data to IX
	CALL	setml		;else set so he has mail in this brd
	RET			;back to where ever
rtm	CALL	bank1		;point to users info
	CALL	rsetml		;else he don't have any mail at all
	RET			;and back
;
mcfoff	PUSH	AF		;save flags
	XOR	A		;remove mail check flag
	LD	(mcf),A		;save it
	POP	AF		;restore flags
	RET			;and go back
;
cphlde	LD	A,H		;get MSB of H
	SUB	D		;minus MSB D
	RET	NZ		;back if unequal
	LD	A,L		;else get LSB HL
	SUB	E		;minus LSB DE
	RET			;C=HL<DE,NC=HL>DE,Z=HL=DE,NZ=HL<>DE
;
musub	LD	A,(usrnum)	;get LSB user number
	CP	(IY+8)		;see if same in msg header
	RET	NZ		;back if not
	LD	A,(usrnum+1)	;else check MSB
	CP	(IY+9)		;see if same in header
	RET			;NZ=no, Z=yes match!
;
muadd	LD	E,(IY+3)	;get offset to next
	LD	D,(IY+4)	;LSB/MSB
	ADD	HL,DE
	RET			;and go back
;
decv3	LD	A,(val3)	;dec val 3
	DEC	A
	LD	(val3),A
	OR	A		;set a flag if needed
	RET			;and return with it
;
thayes	LD	A,(modem)	;test for HAYES modem
	BIT	0,A		;Z=no, NZ=yes
	RET			;back with flags set
;
tstmdf	LD	A,(track2)	;do bit test
	BIT	2,A		;control of DL files
	RET			;Z=single, NZ=multi DLS
;
dlupd	LD	A,(upflag)	;see if DL catalog changed
	OR	A		;Z=no, NZ=YES!
	RET			;back now
;
gtupdr	LD	HL,upld		;point to upload drive list
gtbrdr	LD	A,(board)	;get board we are in
	DEC	A		;minus 1 from board# to give 0-15
	LD	C,A		;move to C
	LD	B,0
	ADD	HL,BC		;point HL to board number
	LD	A,(HL)		;get number of drive
	RET			;and go back
;
gba	LD	IX,(brdadd)	;get board address
	RET
gua	LD	IX,(usradd)	;get user address
	RET
gmt	LD	IX,(msgto)	;get TO address
	RET
gma	LD	IX,(msgadd)	;get message address
	RET
gmay	LD	IY,(msgadd)	;message address to IY
	RET
;
rdix01	LD	L,(IX)		;read in LSB
	LD	H,(IX+1)	;and MSB
	RET
;
rdix34	LD	L,(IX+3)
	LD	H,(IX+4)
	RET
;
rdix45	LD	L,(IX+4)
	LD	H,(IX+5)
	RET
;
rdix56	LD	L,(IX+5)
	LD	H,(IX+6)
	RET
;
rdix67	LD	L,(IX+6)
	LD	H,(IX+7)
	RET			;and go back
;
rdix89	LD	L,(IX+8)	;read IX into HL
	LD	H,(IX+9)
	RET			;and cuts done on rep
;
svix01	LD	(IX),L		;and save same
	LD	(IX+1),H	;LSB/MSB
	RET
;
svix89	LD	(IX+8),L	;saves HL In IX
	LD	(IX+9),H
	RET
;
rdiy89	LD	L,(IY+8)
	LD	H,(IY+9)
	RET
;
sviy89	LD	(IY+8),L
	LD	(IY+9),H
	RET
;
b1ix73	BIT	1,(IX+73)
	RET
;
b7ix73	BIT	7,(IX+73)
	RET
;
b1ix74	BIT	1,(IX+74)
	RET
;
b2ix74	BIT	2,(IX+74)
	RET
;
b7ix74	BIT	7,(IX+74)	;used for testing bits
	RET
;
b7ix75	BIT	7,(IX+75)
	RET
;
mval4	LD	A,(mask)	;testing
	BIT	4,A
	RET
;
mval5	LD	A,(mask)	;used for testing a mask
	BIT	5,A		;removes repeats
	RET
;
val1ix	LD	IX,(val1)	;get value 1
	RET
;
