;Second Part of File Transfer Routines
;for FastPlus.
;Copyright 1988 by Mel Patrick
;Filename - UPDOWN1/ASM
;
doyout	LD	A,'K'		;set for 1K packets
	JR	dt		;and continue
doxout	XOR	A		;set for xmodem
dt	LD	(packet),A	;save it
	CALL	bank2		;select bank2
	CALL	opout		;and open the file (at least try)
	JP	NZ,flerr	;go if disk error on OPEN
	LD	IX,fbuff	;point to file buffer now open
	LD	L,(IX+12)	;get LSB ending rec#
	LD	H,(IX+13)	;get MSB "	"
	LD	(mel1),HL	;save # records
	ADD	HL,HL		;* 2 to get total 128 records
	LD	A,(IX+8)	;get EOF file offset byte
	LD	(mel),A		;save this one too
	DEC	A		;minus 1 to fix calc (trsdos adds 1)
	CP	80H		;less than 1 block?
	JR	NC,whole	;if 80 or greater, both blocks
	DEC	HL		;else minus 1 from total records
whole	CALL	ckpack		;see if 1K in effect
	JR	NZ,whole1	;skip if not, else change calc
	PUSH	HL		;save
	LD	DE,8
	OR	A		;see if total blocks >8
	SBC	HL,DE		;use subtract to find out
	POP	HL		;get back original
	JR	NC,ok21		;if NC, then 8 blocks or greater
	XOR	A		;else we can't use ymodem
	LD	(packet),A	;set different value
	JR	whole1		;and continue
ok21	LD	BC,0		;else we have to count
	LD	DE,8		;by way of subtract
whc	OR	A		;clear the carry
	SBC	HL,DE		;subtract to get size
	JR	C,whc0		;go if too small to subtract
	INC	BC		;else add 1 to count
	JR	Z,whc1		;continue if it works out even
	JR	whc		;loop for count
whc0	ADD	HL,DE		;step back to proper size
whc1	ADD	HL,BC		;HL=remainder, BC=K count
whole1	LD	DE,tfblk	;point to buffer
	CALL	bindec		;convert to ASCII
	LD	HL,msg111	;TOTAL ##### BLOCKS
	CALL	out
	LD	HL,msg80	;YA GOT 60 SECONDS TO START
	CALL	out		;do it
	CALL	credits		;see if credit time saved
	CALL	setpnt		;set starting points
	LD	HL,ctrl		;turn off XLATE table
	SET	2,(HL)		;so we can use it
	CALL	ldblk		;load in some blocks
	LD	B,20		;wait for 100 seconds
nxinv0	PUSH	BC		;save the counter
	LD	BC,(xtime)	;get seconds between sends
nxinvlp	PUSH	BC		;save counter
	CALL	rdbyte		;look for incoming
	POP	BC		;get back counter
	JR	NZ,nxinv1	;skip if no character returned
	CP	21		;else its got to be a 21 NAK
	JR	Z,gcchar	;go if got
	CP	24		;cancel?
	JR	Z,dncan		;cancel if yes
	CP	'C'		;else do we want CRC type of output?
	CALL	Z,setcrc	;go if yes
	JR	Z,gcchar	;go if CRC requested
nxinv1	DEC	BC		;minus 1 from count
	LD	A,B
	OR	C
	JR	NZ,nxinvlp	;loop for count
	CALL	cd		;check for carrier
	POP	BC		;else get back outside loop
	JP	NZ,hbort	;go if aborted
	DJNZ	nxinv0		;loop for maximum count
	JP	dofile		;abort or return
dncan	POP	BC		;remove outside loop
	JP	letsgo		;and back to menu (say we got it)
gcchar	POP	BC		;fix the stack, got a 21
	CALL	xfer		;show either CRC or SUM msgs
	CALL	settry		;set tries to 10
send	CALL	sndhd		;go send header
	LD	DE,0		;set to zero for checksum
	LD	HL,(xadd)	;point to XMODEM block to send
	LD	B,128		;characters to send
	CALL	sndblk		;go send out block
	JR	wfrec		;and continue
sndbd0	CALL	badone		;show error in sending
	CALL	adderr		;add 1 to error list
	LD	B,A		;move in case of too many
	CALL	ckpack		;check for 1K
	JR	NZ,smblk	;go if small blocks
	LD	A,6
	CP	B		;switch down after 4 errors
	JR	NZ,notyet	;continue if within limits
	XOR	A		;else remove ymodem
	LD	(packet),A	;save it
notyet	JR	send		;and send block
smblk	LD	A,10		;see if 10 errors
	CP	B		;?
	JR	NZ,send		;re xmit the block if not at 10
	JP	flabrt		;and do a file abort
wfrec	LD	H,4		;allow 4 loops before resend
wfrec1	LD	C,150		;loop value to use
burp	LD	B,225		;timing loops
wfrec0	PUSH	BC		;save outside loop
	CALL	rdbyte		;wait for read a byte
	POP	BC		;get back counter
	JR	NZ,wf0		;skip if no char received
	CP	21		;else repeat send?
	JR	Z,sndbd0	;rexmit then
	CP	6		;else send next block
	JR	Z,sndxt		;go if yes
	CP	24		;else CANCEL
	JP	Z,dofile	;continue if not CTRL X
wf0	CALL	cd		;check for carrier
	JP	NZ,dofile	;exit if lost
	DJNZ	wfrec0		;loop for B counts
	DEC	C		;then minus 1 from outside loop
	JR	NZ,burp		;continue if not timed out
	DEC	H		;set loop to 10
	JR	NZ,wfrec1	;loop for more
	JR	sndbd0		;assume bad block try re-sync
sndxt	CALL	addblk		;go add 1 to block
	CALL	settry		;set error to 10 times
	CALL	ckpack		;see if in 1K packets
	JP	Z,reload	;reload if yes
	LD	A,(block)	;get blocks remaining to send
	DEC	A		;minus 1 for this block
	LD	(block),A	;save it
	OR	A		;if 0, then all 12 have been sent
	JR	Z,reload	;so we have to reload another 12
	CALL	cv63		;add 128 for next block
	JP	send		;loop for another block now
;
reload	CALL	ldblk		;load x number of blocks
	JP	send		;and send new block
;
xdone	LD	A,4		;send EOT byte
	LD	(upflag),A	;set for NZ to show number increase
	CALL	sbyte		;do it
	LD	H,4		;allow 4 times
xlp	LD	C,150		;timing loops
xdone0	LD	B,200		;time out value
xdone1	PUSH	BC		;save it
	CALL	rdbyte		;wait for ACK
	POP	BC		;get back counter
	JR	NZ,xdone2	;continue if no character
	CP	6		;else must be a 6
	JP	Z,upfile	;go if correct character
	CP	13		;else c/r for done
	JP	Z,upfile	;continue if yes
xdone2	CALL	cd		;check for carrier
	JP	NZ,dofile	;menu if cd lost
	DJNZ	xdone1		;continue for B counter
	DEC	C		;minus 1 from outside loop
	JR	NZ,xdone0	;loop for more if not done
	DEC	H		;minus 1 from loop
	JR	NZ,xlp		;loop for 10 times
	LD	A,4		;send out eof byte
	CALL	sbyte		;then just quit
	JP	dofile		;and back to menu
;
xmerr0	POP	BC		;remove return address first
	LD	A,4
	CALL	sbyte		;eror escape routine
	JP	flerr		;and show file error
;
chksum	LD	D,A		;save character first
	ADD	A,E		;add previous with new
	LD	E,A		;save new total
	LD	A,D		;get back original
	RET			;and return
;
sndhd	CALL	ckpack		;see if 1K proto
	JR	NZ,sndhd0	;skip if not
	LD	A,stx		;else use STX code
	JR	sndhd1		;and send it
sndhd0	LD	A,1		;send out header byte
sndhd1	CALL	sbyte		;send to remote
	LD	A,(blknum)	;get block number
	CALL	sbyte		;send out block number
	CPL			;1's compliment
	CALL	sbyte		;send out compliment
	CALL	icrc16		;initial CRC value to 0
	CALL	disnum		;show number of block
	RET			;then go back
;
addblk	LD	A,(blknum)	;get last block number
	INC	A		;add 1 to it
	LD	(blknum),A	;save it
	LD	HL,(rec)	;get block total
	INC	HL		;add 1 to total
	LD	(rec),HL	;save it
	RET			;and go back
;
sndblk	CALL	ckpack		;see if 1K packets
	JR	Z,snd1k		;go if yes
sndxx	LD	A,(HL)		;get a byte
	CALL	sbyte		;send to modem
	CALL	chksum		;do the check sum now
	CALL	updcrc		;update CRC value
	INC	HL		;point to next character
	DJNZ	sndxx		;look for 128 character (packet)
	LD	A,(xmode)	;test for CRC or CHECKSUM
	OR	A		;Z=CHECKSUM
	JR	Z,dosum		;go if checksum wanted
sndcrc	CALL	fndcrc		;get total CRC in use
	LD	A,D		;get the MSB
	CALL	sbyte		;send it out, then get LSB and send it
dosum	LD	A,E		;E=checksum
	CALL	sbyte		;send to modem
	RET			;then back to caller
;
snd1k	LD	BC,1024		;length of data block
snd1k0	LD	A,(HL)		;get byte
	CALL	sbyte		;send to remote
	CALL	updcrc		;update crc
	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,snd1k0	;continue til 1024 sent
	JR	sndcrc		;then send out crc
;
doxup	CALL	val1ix		;else just set the bit and leave
	SET	3,(IX+2)	;for XMODEM required
	CALL	ckol		;Z=remote, NZ=local keyboard
	JP	NZ,sucess	;go if SYSOP online
	CP	'Y'		;see if Y modem wanted
	JR	Z,doxupy	;go if ymodem
	JR	doxupx		;continue if not sysop online
;
doxupy	LD	A,'K'		;set for Y modem
	JR	doxst		;and start
doxupx	XOR	A		;set for xmodem
doxst	LD	(packet),A	;save it
	CALL	setpnt		;set starting points
	CALL	upper		;select upper case
	CALL	ckpack		;Z=1K, NZ xmodem
	JR	Z,scrc		;defaults to CRC
	LD	HL,menu6	;Xmodem option types
	CALL	hot		;CRC,CHECKSUM,EXIT
	CP	'E'		;exit to menu?
	JP	Z,erabrt	;abort if E selected
	CP	'1'		;else CRC?
	JR	Z,scrc		;go if that mode wanted
	CP	'2'		;else check CHECKSUM
	JP	NZ,erabrt	;abort if neither one
	LD	A,21		;else set CHECKSUM mode
	JR	setrcv		;and set the mode
scrc	CALL	setcrc		;set the crc mode
	LD	A,'C'		;set for CRC mode
setrcv	LD	(reqest+1),A	;and insert it
	CALL	cv60		;open, check, overwrite...
	LD	B,25		;wait 5 seconds before start
dloop	PUSH	BC
	CALL	delay1		;BC=0, @pause
	POP	BC		;get back value
	DJNZ	dloop		;loop for 5 seconds
	CALL	cd		;check for carrier
	JP	NZ,erafil	;go if lost
	LD	HL,ctrl		;turn off XLATE option
	SET	2,(HL)		;for Xmodem process
	LD	HL,buffer	;point to buffer to start save at
	LD	(xadd),HL	;save it
	CALL	clrtyp		;clear type ahead buffer
	LD	A,(tmin)	;get current time
	LD	(svtime),A	;save it
	LD	B,22		;number of times
sdnak0	PUSH	BC		;save counter
	LD	BC,(xtime)	;get time between sends
reqest	LD	A,21		;send out NAK or 'C'
	CALL	sbyte
	CALL	ckpack		;Z=K (1K), NZ=nope
	JR	NZ,sdnak1	;skip if not in 1K packets
	CALL	sbyte		;else send out CK CK CK
sdnak1	PUSH	BC
	CALL	rdbyte		;see if anything
	POP	BC
	JR	NZ,sdnak2	;skip next compare if nothing
	CP	1		;else look for SOH (nothing else)
	JR	Z,gosoha	;go if received
	CP	stx		;see if 1K
	JR	Z,gotstx	;go if 1K wanted
	CP	24		;CANCEL?
	JP	Z,goerr		;cancelled by remote if yes
sdnak2	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,sdnak1	;loop for RS232 input
	CALL	cd
	POP	BC		;get counter to use
	JP	NZ,erafil	;skip if cd gone
	DJNZ	sdnak0		;do it again
	JP	ercont		;erase and exit if timed out
gotstx	POP	BC		;fix stack
	PUSH	AF		;save char
	CALL	setcrc		;set CRC mode
	CALL	xfer		;show mode in use
	POP	AF		;get back character
stxlp	LD	HL,mel3		;address to store header
	CALL	cv64		;send out header, init CRC
	LD	BC,1026		;bytes to read in
	CALL	stxin		;reads them in
	LD	DE,(crc)	;get crc
	LD	A,D
	OR	E		;Z=CRC OK!, NZ=bad
	JP	Z,gotall	;go if it got it
	JP	xupbad		;else it was bad
;
stxin	CALL	cv65		;read in B bytes
stx0	LD	(HL),A		;save char
	CALL	updcrc		;update crc
	INC	HL
	DEC	BC
	LD	A,B
	OR	C		;loop til BC = 0
	JR	NZ,stxin	;loop til all read in
	RET			;else go back
;
gosoha	POP	BC		;remove counter from stack
	PUSH	AF		;save SOH byte
	CALL	xfer		;show mode in use
	POP	AF		;get back SOH byte now
gosoh0	PUSH	AF		;save char
	XOR	A		;remove 1K proto
	LD	(packet),A	;in case
	POP	AF		;then restore char
	LD	HL,mel3		;where to read in 3 bytes
	LD	DE,0		;set checksum to 0
	CALL	cv64		;send out 3 byte header
	LD	B,128		;and read in the data block
	CALL	up1		;and read in the data
	LD	B,1		;set for 1 byte checksum
	LD	A,(reqest+1)	;see if checksum or CRC
	CP	'C'		;want CRC mode?
	JR	NZ,gocs		;go if checksum mode
	INC	B		;else add 1 to count
	JR	gocrc		;and continue with CRC mode
gocs	CALL	upinp		;read last part
	DEC	HL		;step back one
	LD	A,E		;get checksum
	CP	(HL)		;see if match
gocs0	JP	NZ,xupbad	;go if bad checksum
	JR	gotall		;else we got it all
gocrc	CALL	up1		;read in
	LD	DE,(crc)	;get CRC value
	LD	A,D		;and test it
	OR	E		;must = 0
	JR	gocs0		;and ocntinue
;
upinp	CALL	cv65		;read in B number of bytes
gosoh1	LD	(HL),A		;save in buffer
	INC	HL		;point to next
	DJNZ	upinp		;loop for 1 full block
	RET			;and back to caller
;
up1	CALL	cv65		;read in B characters
go1	LD	(HL),A		;save in buffer
	CALL	chksum		;add for checksum
	CALL	updcrc		;update the CRC
	INC	HL		;point to next
	DJNZ	up1		;and loop for B counter
	RET			;then back to caller
;
gotall	LD	HL,mel3		;address of header
	CALL	ckpack		;see if 1K proto
	JR	NZ,not1k	;skip if not
	LD	A,(HL)		;else see if we match
	CP	stx		;must be = 2
	JR	stxchk		;and continue
not1k	LD	A,(HL)		;get first byte
	CP	1		;must a 1 (SOH)
stxchk	JR	NZ,xupbad	;go if upload bad
	INC	HL		;now look at the block number
	LD	A,(HL)		;get the byte
	INC	HL		;point to 1's compliment of it
	CPL			;compliment it
	CP	(HL)		;check it against reference
	JR	NZ,xupbad	;bad, if block and compliment don't match
	CPL			;change it back to original blk#
	LD	B,A		;move received block number to B
	LD	A,(blknum)	;get block number we should have gotten
	CP	B		;if Z flag, received block in order
	JP	Z,dox		;continue if proper block
	JP	NC,dupblk	;B<A received duplicate block
	CALL	ctrlx		;send control X
	JP	ercont		;erase download from file
xupbad	CALL	badone		;show error in receive
	CALL	icrc16		;reset CRC mode
	CALL	adderr		;add another for this error
	OR	A		;see if bombed out
	JR	NZ,xupb1	;continue if still ok
	JP	ercont		;too may errors, erase and continue
xupb1	CALL	clrtyp		;clear type ahead buffer
	LD	A,21		;send NAK to show bad
	CALL	sbyte		;send to remote
xtest	LD	H,10		;10 loops before abort
xtest0	LD	L,5		;renak after 5 seconds
xtest1	LD	C,150		;outside loop
xt4	LD	B,200		;approximate time
xupb	PUSH	BC		;save it
	CALL	rdbyte		;check for data
	POP	BC		;get back inside counter
	JR	NZ,xupbb	;skip check if no character
	CP	1		;else must be SOH
	JP	Z,gosoh0	;go if thats it
	CP	2		;want 1K proto
	JP	Z,stxlp		;continue if yes
	CP	24		;else cancel?
	JP	Z,goerr0	;go if cancel wanted
	CP	4		;end of xmit?
	JR	Z,xmitd		;go if rec done
xupbb	DJNZ	xupb		;minus 1 from counter
	CALL	cd		;check for carrier
	JP	NZ,erafil	;go if carrier gone
	DEC	C		;else minus 1 from outside loop
	JR	NZ,xt4		;loop for more if not timed out
	DEC	L		;do a NAK every 5 seconds
	JR	NZ,xtest1	;go if not wanted yet
	CALL	clrtyp		;empty buffer
	LD	A,21		;else send one out
	CALL	sbyte		;send to remote
	DEC	H		;minus 1 from H
	JR	NZ,xtest0	;loop for more if not ready yet
	JP	ercont		;exit and erase
;
goerr	POP	BC		;else its a cancel
goerr0	LD	A,(credit)	;test for allowed to have a time credit
	OR	A		;Z=no, NZ=yes
	JR	Z,goerra	;skip if not
	LD	A,(svtime)	;else restore time
	LD	(tmin),A	;save it
goerra	JP	dofile		;so forget the transfer (menu)
;
dupblk	CALL	shdup		;show duplicate received
	LD	A,6		;request NEXT block
	CALL	sbyte		;send to remote
	JR	xupc		;then try to get him up to where we are
;
dox	CALL	addb		;add 1 to block
	CP	10		;full?
	JR	Z,wr2dsk	;go if yes
	CALL	ckpack		;see if 1K proto
	JR	Z,wr2dsk	;go if packet received
	CALL	xtsub		;else inc counters and screen
xupc	JP	xtest		;and continue
wr2dsk	CALL	xsave		;save out the blocks
	CALL	xtsub		;update info
	CALL	cv66		;reset all blocks and counters
	JR	xupc		;and continue
;
xtsub	LD	A,6		;send to remote for next block
	CALL	sbyte		;send it
	CALL	disnum		;display block number
	CALL	addblk		;add 1 to block total
	CALL	cv63		;add 128 for next block
	CALL	settry		;see to 10 errors
	RET			;and go back
;
xmitd	LD	A,6		;all done rec now
	CALL	sbyte		;inform remote
	CALL	xsave		;else save new data to disk
	CALL	getk		;get file data before closing file
xclose	JP	cv62		;close, insert K, sucess
;
xsave	LD	HL,buffer	;point to start of buffer
	LD	A,(block)	;get total blocks to write out
	OR	A		;if A=0, nothing was rec
	RET	Z		;just go back
	CALL	ckpack		;else see if 1K proto
	JR	NZ,x2dska	;go to other routine if not
	LD	B,4		;write to disk
stxout	PUSH	BC		;save counter
	CALL	cv67		;write to disk
	POP	BC
	JP	NZ,ercont	;go if write error
	DJNZ	stxout		;else loop
	RET			;and then back
;
x2dska	LD	A,(block)	;get blocks in buffer
	CP	3		;see if less than 3
	JR	C,smblk0	;go if small block
	CALL	cv67		;write 256 to disk
	JP	NZ,ercont	;erase if write error
	LD	A,(block)	;get block counter
	DEC	A
	DEC	A
	LD	(block),A	;save it
	OR	A		;Z=all wrote out
	RET	Z		;back if yes
	JR	x2dska		;else loop for more
;
smblk0	LD	B,A		;else,move into loop
x2dsk1	LD	C,128		;bytes to write out
x2dsk0	PUSH	BC
	CALL	fcput		;write a byte to disk (DE=FBUFF C=char)
	POP	BC
	JP	NZ,ercont	;go if disk write error
	INC	HL		;point to next
	DEC	C		;minus 1 from count
	JR	NZ,x2dsk0	;continue for 128 bytes
	DJNZ	x2dsk1		;loop til done
	RET			;back to caller now
;
flerr	CALL	ctrlx		;send control X to cancel
	CALL	delay1		;wait 1 second before error msg
	LD	HL,err10	;File Error Msg
flerr0	CALL	out		;send it out
	CALL	cv56		;select bank, pointer to IX
	SET	4,(IX+2)	;set bit to show file was bad
	JP	dofile		;and back to menu
;
flerr1	LD	HL,err11	;show them file is BAD
	JR	flerr0		;and continue
;
flerr2	CALL	nfg		;erase from catalog slot
	CALL	ctrlx		;send control x to cancel
	LD	HL,err13	;bad filename
	JP	erdow0		;send and abort
;
badone	LD	HL,msg65	;BLOCK ERROR
bdone	CALL	disply		;show it
	RET			;and go back
shdup	LD	HL,msg66	;DUPLICATE BLOCK
	JR	bdone		;and show it
;
ldblk	LD	A,(rdflag)	;0=continue, 1=all done
	OR	A
	JR	Z,ldcont	;continue if not done
	POP	AF		;else remove ret address
	JP	xdone		;and we are all done
ldcont	CALL	cv66		;reset blocks and counters
ldb	LD	DE,fbuff	;point to file buffer
	LD	HL,dummy
	LD	A,@read		;and read in 256 bytes
	RST	svc		;now! (128*2)
	JP	NZ,xmerr0	;abort if read error
	LD	HL,dummy	;point to buffer
	LD	DE,(xadd)	;point to data address
	LD	BC,256		;bytes to copy out
	LDIR			;and move them
	LD	(xadd),DE	;save for next read
	LD	HL,(mel1)	;get total block count
	DEC	HL		;minus 1 from it
	LD	(mel1),HL	;save for next time
	LD	A,H
	OR	L		;Z=all done
	JR	Z,rdsome	;go if end of file all read in
	CALL	addb		;and add 1 block to counter
	CALL	addb
	LD	B,A		;move for checking
	CALL	ckpack		;see if 1K packets
	JR	Z,pack1		;go if in 1K
	LD	A,10		;else check it
	JR	docmp		;and compare it
pack1	LD	A,8		;1K size
docmp	CP	B		;see if enough loaded
	JR	NZ,ldb		;continue if not
	LD	HL,buffer	;reset pointer
	LD	(xadd),HL	;point to data
	RET			;and go back now
;
rdsome	LD	A,(mel)		;get EOF byte (offset)
	DEC	A		;minus 1 from count
	CP	80H		;check for 1 block or two
	JR	NC,twoblk	;go if both blocks
pad	INC	A		;offset to data
	CP	00H		;whole file?
	JR	Z,swf		;go if yes
	LD	E,A
	LD	D,0
	LD	HL,(xadd)	;point to buffer
	DEC	H		;back up 256 for last read
	ADD	HL,DE		;HL points to data
	PUSH	HL
	POP	DE
	INC	DE
	LD	(HL),00H	;end marker
	LD	B,A		;move over offset
	LD	A,0FFH		;max of 256
	SUB	B		;minus offset 
	OR	A		;Z=only empty last byte in file
	JR	Z,swf		;don't block move anything
	LD	C,A
	LD	B,0
	LDIR			;and block load in markers
swf	JR	rdeof0		;and continue
twoblk	PUSH	AF		;save EOF marker
	CALL	addb		;add to block counter
	POP	AF		;get it back
	JR	pad		;and pad the block
rdeof0	CALL	addb		;add 1 block number
rdeof1	LD	A,1		;set for no further reads
	LD	(rdflag),A	;save it
	LD	HL,buffer	;point to data
	LD	(xadd),HL	;save it
	LD	A,(block)	;see if even 8 blocks read in
	CP	8		;yes?
	RET	Z		;back if yes
	XOR	A		;else we have to switch to xmodem
	LD	(packet),A	;remove 1K proto
	RET			;and then continue
;
addb	LD	A,(block)	;get blocks to send
	INC	A		;add 1 for partial block
	LD	(block),A	;save it
	RET			;and now go back
;
disnum	LD	HL,(rec)	;get number of blocks
	LD	DE,m67b		;buffer to use
	CALL	bindec		;convert to ASCII
	LD	HL,msg67	;then display it
	CALL	disply		;on our screen only
	RET			;then go back
;
openf	CALL	mvthfl		;move the file to use
	LD	A,13		;always add a c/R
	LD	(DE),A		;in end of buffer
	LD	HL,dummy	;point to filename location
	CALL	crfcb		;and try to create a filespec out of it
	RET	NZ		;back if we failed (never fails)
	CALL	dojim		;now change any . to a /
	LD	HL,fbuff	;point to FCB buffer
	LD	BC,20		;bytes to look through for 03 marker
	LD	A,03H		;always marks the end of an FCB buffer
	CPIR			;and look for it
	DEC	HL		;back up one
	LD	(HL),':'	;we always find it too
	INC	HL		;point to where drive # goes
	PUSH	HL		;save pointer
	CALL	gtupdr		;get upload drive#
	POP	HL		;and stuff it in
	LD	(HL),A		;insert ASCII where we want it
	INC	HL		;point to where new 03H has to go
	LD	(HL),03H	;we now have the terminator ready
	JP	flinit		;and overwrite or create the file
opout	CALL	mvthfl		;move the file to use
	LD	A,13		;then stuff in a c/r if needed
	LD	(DE),A		;so we can work with it
	CALL	dodot		;check . to / for opening file
pst0	LD	A,@open		;use open code only
	LD	(topen+1),A	;insert to use in OPEN
pst	LD	HL,dummy
	CALL	crfcb		;create a file control block
	RET	NZ		;back if can't open
topen	LD	A,@init		;CREATE or OPEN a file
	JP	flstart		;use RET in flstart routine
;
setpnt	LD	A,1		;setup block number
	LD	(blknum),A	;save it for xmit
	XOR	A		;set flag to off
	LD	(rdflag),A	;save for block loading
	LD	(block),A	;save it
	LD	(xmode),A	;default to CHECKSUM mode
	LD	HL,1		;start at record 1
	LD	(rec),HL	;save it
	RET			;back when done
;
adderr	LD	A,(try)		;get errors so far
	DEC	A		;minus 1 from total
	LD	(try),A		;save them
	RET			;then go back
;
setcrc	LD	A,1		;set for CRC mode
	LD	(xmode),A	;save it
	CP	A		;set the zero flag
	RET			;and go back
;
icrc16	PUSH	HL		;save whatever
	LD	HL,0		;reset crc points to 0
	LD	(crc),HL	;save them
	POP	HL		;then continue with restore
	RET			;and go back
;
updcrc	PUSH	BC
	PUSH	HL
	LD	B,8		;digits
	LD	C,A		;move character to C
	LD	HL,(crc)	;get crc value now
updlp	RLC	C		;shift all regs
	RL	L
	RL	H
	JR	NC,skipit
	LD	A,H
	XOR	10H
	LD	H,A
	LD	A,L
	XOR	21H
	LD	L,A
skipit	DJNZ	updlp		;update loop
	LD	(crc),HL	;save value to use
	POP	HL
	POP	BC
	RET			;and go back
;
fndcrc	XOR	A		;zero it out
	CALL	updcrc		;????
	XOR	A		;zero it out again
	CALL	updcrc
	LD	DE,(crc)	;get CRC value
	RET			;and go back with CRC in DE
;
xfer	LD	HL,msg64	;CHECKSUM MODE
	LD	A,(xmode)	;get type of xfer wanted
	OR	A		;0=checksum NZ=CRC
	JR	Z,shsum		;go if checksum
	LD	HL,msg63	;CRC MODE
shsum	CALL	disply		;show message to us only
	RET			;and go back
;
sucess	CALL	wait2		;wait 2 seconds for remote
	CALL	cv56		;select bank, IX to pointer
	LD	L,(IX+20)	;test for anything received
	LD	H,(IX+21)
	LD	A,H
	OR	L
	JR	Z,nogood	;skip if file was useless
	PUSH	IX		;save for later
	CALL	bank1		;reselect users file
	LD	L,(IX+30)	;add 1 for upload
	LD	H,(IX+31)
	INC	HL
	LD	(IX+30),L
	LD	(IX+31),H	;insert back in
	CALL	creditr		;restore time credit check
	CALL	bank2		;select download bank again
	POP	IX		;get back file address
	BIT	0,(IX+2)	;test for file for SYSOP only
	JR	Z,no4f		;go if not for sysop only
	LD	(IX+15),0DH	;insert a CR in case
	PUSH	IX		;then move filename to print
	POP	HL		;HL points to filename uploaded
	INC	HL		;step to filename
	INC	HL
	INC	HL
	CALL	lprint		;send it to printer
	LD	HL,buff2	;then point to description
	CALL	lprint		;send HL to printer (if possible)
nolp	LD	A,'*'		;show special for you!
	LD	(ustat+34),A	;save it
	CALL	u2scr		;move to screen
	CALL	nfg		;remove from slot, good upload
	JR	letsgo		;and continue
;
nogood	CALL	opout		;move the file, and open it
	CALL	rmvfil		;and remove the file from disk
	CALL	nfg		;remove the entry from slot
	JR	letsgo0		;and continue
;
no4f	CALL	countd		;and count the downloads now
	CALL	calbrd		;and update on screen
	LD	A,'U'		;show upload file
	LD	(ustat+32),A	;insert in user data
	LD	(upflag),A	;indicate we have an UPLOAD (NZ)
	LD	A,(svtime)	;get original time limit
	LD	(tmin),A	;restore it to what it was
dnok	CALL	u2scr		;and move to display
letsgo	LD	HL,msg68	;let them know it when well
	CALL	hot		;send it out
letsgo0	JP	dofile		;and back to file menu
;
nfg	CALL	bank2		;select bank
	CALL	clrent		;and remove the file
	RET			;and then back
;
getk	LD	IX,fbuff	;get dcb info first
	LD	A,(IX+6)	;get drive in use
	AND	7		;mask out any additional char
	LD	L,A		;store in L
	LD	H,(IX+7)	;get DEC from block
	DEC	H		;try this one
	RET			;then go back
;
insrtk	LD	C,H		;then setup to get file size
	LD	B,L		;DEC and DRIVE
	LD	HL,dummy	;buffer to use
	LD	A,@ramdir
	RST	svc
	CALL	val1ix		;get address of file data
	LD	IY,dummy	;point to buffer of info
	LD	A,(IY+20)	;get LSB size
	LD	(IX+20),A	;move it
	LD	A,(IY+21)	;get MSB size
	LD	(IX+21),A	;insert it
	RET			;and go back
;
flabrt	CALL	ctrlx		;send out CTRL X
	JP	dofile		;and back to menu
;
upfile	CALL	clrtyp		;empty buffer in case
	CALL	cv56		;select bank, IX to pointer
	LD	L,(IX+22)	;get LSB times access
	LD	H,(IX+23)	;MSB
	INC	HL
	LD	(IX+22),L	;and add 1 then reinsert
	LD	(IX+23),H
	LD	A,(IX+2)	;get status bits in case
	PUSH	AF		;save for later
	CALL	bank1		;select the users bank now
	LD	L,(IX+28)	;get total they have downloaded
	LD	H,(IX+29)
	INC	HL		;add 1 for this file
	LD	(IX+28),L	;and insert new data back in
	LD	(IX+29),H
	CALL	wait2		;wait for 2 seconds
	LD	A,'D'		;show downloaded
	LD	(ustat+33),A	;insert D for downloaded
	POP	AF		;get back status bits
	BIT	6,A		;Z=leave alone, NZ=remove it after DL
	JP	NZ,singdl	;allow only one download of file
	JP	dnok		;usr 2 screen and sucess!
;
dojim	LD	HL,fbuff	;point to ASCII FCB
	JR	dodot0		;and continue
dodot	LD	HL,dummy	;point to filespec
dodot0	LD	BC,12		;bytes to look through
	LD	A,'.'		;byte to look for
	CPIR			;see if HL=A
	RET	NZ		;return if no period
	DEC	HL		;correct address of find
	LD	(HL),'/'	;else change it to a slash
	RET			;and go back
;
rmvfl	CALL	chksys		;see if local or MASTER
	JR	NZ,rtf		;allow if local or master
	LD	C,2		;check BIT 1
	CALL	chkre0		;see if remote sysop
	JR	NZ,rtf		;go if a remote sysop
	LD	A,(track1)	;else check for allowed
	BIT	3,A		;Z=not allowed NZ=yes
	JP	Z,dofile	;back if no access
rtf	LD	A,1		;set mask value ON
rtf1	LD	(mask),A	;save it
	JP	dodo0		;and start as if downloading
;
cfstat	CALL	chksys		;see if local or remote
	JR	NZ,rtf0		;go if local or master
	LD	C,2
	CALL	chkre0		;check him out
	JP	Z,dofile	;back if not allowed
rtf0	LD	A,2		;else set flag to change board access
	JR	rtf1		;and continue
;
erafil	CALL	closef		;and close the file
	JP	NZ,eradow	;if error, just erase entry
	CALL	fspace		;and remove the file
	JP	eradow		;and go, loss of cd
;
ercont	CALL	closef		;else close the file
	JP	NZ,erdow	;erase and continue, still online
ercon	CALL	fspace		;else free up the space
	JP	erdow		;and continue
;
mel	DB	0
mel1	DW	0		;all used for XMODEM
mel3	DS	3		;3 bytes for header info
packet	DB	0		;use for YMODEM
;
